import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.Handlers";
import "moebius92.Misc";
import "moebius92.NormalQuickslot";

_G.trim = function(s)
	return string.gsub(s, "^%s*(.-)%s*$", "%1");
end

usageMultiplier = 4;
meanTime = 0.3;
minTime = 0.2;

quickKeys = { 0x1000002A, 0x10000032, 0x1000003E, 0x10000047, 0x10000050, 0x10000057,
              0x1000005F, 0x10000067, 0x10000071, 0x1000004F, 0x10000056, 0x1000005E,

              0x10000066, 0x10000070, 0x10000078, 0x10000082, 0x1000008E, 0x10000096,
              0x1000009E, 0x10000011, 0x10000019, 0x10000022, 0x10000029, 0x10000031,

              0x1000003D, 0x10000046, 0x1000004E, 0x10000055, 0x1000005D, 0x10000005,
              0x1000000B, 0x10000010, 0x10000018, 0x10000021, 0x10000028, 0x10000030,

              0x1000003C, 0x10000045, 0x1000004D, 0x1000008D, 0x10000095, 0x1000009D,
              0x100000A3, 0x100000AD, 0x100000B0, 0x100000B9, 0x10000004, 0x1000000A,

              0x1000000F, 0x10000020, 0x10000027, 0x1000002F, 0x1000003B, 0x10000044,
              0x1000004C, 0x10000054, 0x1000005C, 0x10000065, 0x1000006F, 0x100000AC,

              0x100000AF, 0x100000B8, 0x10000003, 0x10000009, 0x1000000E, 0x10000017,
              0x1000001F, 0x10000026, 0x1000002E, 0x1000009C, 0x100000A2, 0x100000AB };

curSkillTable = { };
curSkillAlias = { };

HunterRangedSkills = {
	"Barbed Arrow",
	"Bards Arrow",
	"Distracting Shot",
	"Heart Seeker",
	"Quick Shot",
	"Rain of Thorns",
	"Swift Bow"
};

traitTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["Hidden Dagger"]							= { set = "Quiet Knife" },
		["Strike from Shadows"]						= { set = "Quiet Knife" },
		["Cunning Wound"]							= { set = "Quiet Knife" },
		["Focused Eye"]								= { set = "Quiet Knife", cooldown = { ["Aim"] = "-30s" } },
		["Strategic Planning"]						= { set = "Quiet Knife", cooldown = { ["Location is Everything"] = "-120s" } },
		["Spatial Sense"]							= { set = "Quiet Knife", cooldown = { ["Well Placed Strike"] = "-60s" } },
		["Sharp Wit Sharp Blade"]					= { set = "Quiet Knife" },
		["Ambidextrous"]							= { set = "Quiet Knife" },

		["Opportunist"]								= { set = "Mischief Maker" },
		["Trickster"]								= { set = "Mischief Maker" },
		["Disabling Attack"]						= { set = "Mischief Maker" },
		["Blind Fury"]								= { set = "Mischief Maker" },
		["Perplexing Riddle"]						= { set = "Mischief Maker" },
		["Appraising Eye"]							= { set = "Mischief Maker" },
		["Confound the Fools"]						= { set = "Mischief Maker" },
		["Complicated Terms"]						= { set = "Mischief Maker" },

		["Honed Wit"]								= { set = "Gambler", cooldown = { ["Clever Retort"] = "-30s" } },
		["Even the Odds"]							= { set = "Gambler", cooldown = { ["Escape Clause"] = "-300s" } },
		["Cruel Odds"]								= { set = "Gambler" },
		["Overwhelming Odds"]						= { set = "Gambler" },
		["Footpad"]									= { set = "Gambler" },
		["Leaf Walker"]								= { set = "Gambler" },
		["Swift and Subtle"]						= { set = "Gambler" },
		["Side Step"]								= { set = "Gambler" },

		["Stick and Move"]							= { set = "Legendary" },
		["Sweep the Leg"]							= { set = "Legendary", cooldown = { ["Trip"] = "-120s" } },
		["Flashing Blades"]							= { set = "Legendary", enable = { "Flashing Blades" } },
		["Exposed Throat"]							= { set = "Legendary", enable = { "Exposed Throat" } },
		["Practiced Bluff"]							= { set = "Legendary", cooldown = { ["Feint Attack"] = "-240s" } },
		["Little Annoyances"]						= { set = "Legendary", cooldown = { ["A Small Snag"] = "-240s" } },
		["Dealings Done"]							= { set = "Legendary", cooldown = { ["Lucky Strike"] = "-240s" } },

		["Quiet Knife"]								= { set = "Set" },
		["Mischief Maker"]							= { set = "Set",
														[3] = { cooldown = { ["Reveal Weakness"] = "-5s" } },
														[4] = {
															skills = { 
																"Trick: Counter Defence",
																"Trick: Disable",
																"Trick: Dust in the Eyes",
																"Trick: Enrage",
																"Clever Retort",
																"Mischievous Glee",
																"Startling Twist"
															},
															cooldown = "-5s"
														}
													  },
		["Gambler"]									= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Captain] = {
		["Alert Guard"]								= { set = "!Leader of Men" },
		["Echoing Shout"]							= { set = "!Leader of Men" },
		["Improved Routing Cry"]					= { set = "!Leader of Men" },
		["Captains Victory"]						= { set = "!Leader of Men" },
		["Last Stand"]								= { set = "!Leader of Men" },
		["Composure"]								= { set = "!Leader of Men" },
		["Intimidation"]							= { set = "!Leader of Men" },
		["Tactical Prowess"]						= { set = "!Leader of Men" },

		["Fear no Darkness"]						= { set = "!Hands of Healing" },
		["Strong Voice"]							= { set = "!Hands of Healing" },
		["Blood of Numenor"]						= { set = "!Hands of Healing",
													    cooldown = { ["Escape from Darkness"] = "-600s" }, 
													    induction = { ["Escape from Darkness"] = "-2s" }
													  },
		["Captains Hope"]							= { set = "!Hands of Healing" },
		["Now for Wrath"]							= { set = "!Hands of Healing" },
		["Deeds before Words"]						= { set = "!Hands of Healing" },
		["Relentless Optimism"]						= { set = "!Hands of Healing" },
		["Strength from Within"]					= { set = "!Hands of Healing" },

		["Renewed Voice"]							= { set = "!Lead the Charge", cooldown = { ["Battle Shout"] = "-5s" } },
		["Turn of the Tide"]						= { set = "!Lead the Charge" },
		["Captains Valour"]							= { set = "!Lead the Charge" },
		["Expert Attacks"]							= { set = "!Lead the Charge" },
		["Precise Ally"]							= { set = "!Lead the Charge" },
		["Loyalty"]									= { set = "!Lead the Charge" },
		["Battle Master"]							= { set = "!Lead the Charge" },
		["Adherent of Elendil"]						= { set = "!Lead the Charge" },

		["Shield of the Dunedain"]					= { set = "Legendary", enable = { "Shield of the Dunedain" } },
		["In Defense of Middle Earth"]				= { set = "Legendary", enable = { "In Defense of Middle Earth" } },
		["Oathbreakers Shame"]						= { set = "Legendary", enable = { "Oathbreaker's Shame" } },
		["Fellowship Brother"]						= { set = "Legendary" },
		["Leader of Men"]							= { set = "Legendary" },
		["Hands of Healing"]						= { set = "Legendary", cooldown = { ["Valiant Strike"] = "-30s" } },
		["Master of War"]							= { set = "Legendary" },
		
		["!Leader of Men"]							= { set = "Set",
														[2] = {
															skills = { "Noble Mark", "Revealing Mark", "Telling Mark" },
															cooldown = "-10s"
														},
														[3] = { cooldown = { ["Threatening Shout"] = "-10s" } }
													  },
		["!Hands of Healing"]						= { set = "Set" },
		["!Lead the Charge"]						= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Champion] = {
		["Stalwart Blade"]							= { set = "Deadly Storm" },
		["Winds of the Storm"]						= { set = "Deadly Storm" },
		["Eye of the Storm"]						= { set = "Deadly Storm" },
		["Mighty Blast"]							= { set = "Deadly Storm" },
		["Battle Acumen"]							= { set = "Deadly Storm" },
		["Fervent Rage"]							= { set = "Deadly Storm" },
		["Swift to Anger"]							= { set = "Deadly Storm" },
		["Improved Rend"]							= { set = "Deadly Storm" },

		["Blood Lust"]								= { set = "Berserker" },
		["Vicious Strikes"]							= { set = "Berserker" },
		["Deadly Strikes"]							= { set = "Berserker" },
		["Deep Strikes"]							= { set = "Berserker" },
		["Athletic"]								= { set = "Berserker", cooldown = { ["Sprint"] = "-120s" } },
		["Controlled Fury"]							= { set = "Berserker" },
		["Bountiful Mercy"]							= { set = "Berserker" },
		["Flurry of Blows"]							= { set = "Berserker" },

		["Call of the Wild"]						= { set = "Martial Champion" },
		["At the Ready"]							= { set = "Martial Champion" },
		["Aggressive Exchange"]						= { set = "Martial Champion" },
		["Reprisal"]								= { set = "Martial Champion" },
		["Braced Against Defeat"]					= { set = "Martial Champion" },
		["Time of Need"]							= { set = "Martial Champion", cooldown = { ["Dire Need"] = "-300s" } },
		["Vigour of Champions"]						= { set = "Martial Champion" },
		["Tight Grip"]								= { set = "Martial Champion", cooldown = { ["Hedge"] = "-50%" } },

		["Ferocious Strikes"]						= { set = "Legendary", enable = { "Ferocious Strikes" } },
		["Controlled Burn"]							= { set = "Legendary", enable = { "Controlled Burn" } },
		["Raging Blades"]							= { set = "Legendary", enable = { "Raging Blades" } },
		["Fight On"]								= { set = "Legendary", enable = { "Fight On" } },
		["Deathstorm"]								= { set = "Legendary" },
		["Continuous Blood Rage"]					= { set = "Legendary", enable = { "Continuous Blood Rage" } },
		["Invincible"]								= { set = "Legendary" },

		["Deadly Storm"]							= { set = "Set" },
		["Berserker"]								= { set = "Set",
													    [4] = { cooldown = { ["Merciful Strike"] = "-10s" } } },
		["Martial Champion"]						= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Guardian] = {
		["Guardians Ward"]							= { set = "Fighter of Shadow" },
		["Selfless Defense"]						= { set = "Fighter of Shadow" },
		["Defensive Expertise"]						= { set = "Fighter of Shadow" },
		["Deflected Blows"]							= { set = "Fighter of Shadow" },
		["Controlled Breathing"]					= { set = "Fighter of Shadow" },
		["Brave Heart"]								= { set = "Fighter of Shadow", cooldown = { ["Warriors Fortitude"] = "-90s" } },
		["Stoic"]									= { set = "Fighter of Shadow" },
		["Final Straw"]								= { set = "Fighter of Shadow" },

		["Grim Challenge"]							= { set = "Defender of the Free", cooldown = { ["Challenge"] = "-15s" } },
		["Harasser"]								= { set = "Defender of the Free", cooldown = { ["Vexing Blow"] = "-2.5s" } },
		["Reactive Block"]							= { set = "Defender of the Free" },
		["Threatening Presence"]					= { set = "Defender of the Free" },
		["Heat of Battle"]							= { set = "Defender of the Free", cooldown = { ["Thrill of Danger"] = "-120s" } },
		["Litany of Challenge"]						= { set = "Defender of the Free" },
		["Shield of Fire"]							= { set = "Defender of the Free" },
		["Quick of Foot"]							= { set = "Defender of the Free", cooldown = { ["Stamp"] = "-15s" } },

		["Hit Where it Hurts"]						= { set = "Keen Blade" },
		["Raw Power"]								= { set = "Keen Blade" },
		["Parried Blows"]							= { set = "Keen Blade" },
		["Stinging Blow"]							= { set = "Keen Blade", cooldown = { ["Sting"] = "-3s" } },
		["Blocking Force"]							= { set = "Keen Blade", cooldown = { ["Force Opening"] = "-6s" } },
		["Strong Lungs"]							= { set = "Keen Blade", cooldown = { ["Deep Breath"] = "-50%" } },
		["Quickness"]								= { set = "Keen Blade" },
		["To the Rescue"]							= { set = "Keen Blade" },

		["To the King"]								= { set = "Legendary", enable = { "To the King" } },
		["Challenge the Darkness"]					= { set = "Legendary", enable = { "Challenge the Darkness" } },
		["Guardians Threat"]						= { set = "Legendary", enable = { "Guardian's Threat" } },
		["Shield Smash"]							= { set = "Legendary", enable = { "Shield-smash" } },
		["Heart of Fire"]							= { set = "Legendary", cooldown = { ["Take to Heart"] = "-60s" } },
		["Litany Master"]							= { set = "Legendary" },
		["Haemorrhage"]								= { set = "Legendary" },

		["Fighter of Shadow"]						= { set = "Set" },
		["Defender of the Free"]					= { set = "Set", [4] = { cooldown = { ["Stamp"] = "-10s" } } },
		["Keen Blade"]								= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["True Shot"]								= { set = "Bowmaster" },
		["Hail of Arrows"]							= { set = "Bowmaster" },
		["Barbed Fury"]								= { set = "Bowmaster" },
		["Swift and True"]							= { set = "Bowmaster" },
		["Fast Draw"]								= { set = "Bowmaster", induction = { ["Barbed Arrow"] = "-0.1s", ["Swift Bow"] = "-0.2s" } },
		["Swift Mercy"]								= { set = "Bowmaster" },
		["Critical Eye"]							= { set = "Bowmaster" },
		["Shot through the Heart"]					= { set = "Bowmaster" },

		["Sturdy Traps"]							= { set = "Trapper of Foes" },
		["Combat Traps"]							= { set = "Trapper of Foes" },
		["Strong Intimidation"]						= { set = "Trapper of Foes" },
		["Spring Loaded Traps"]						= { set = "Trapper of Foes" },
		["Barbed Hindrance"]						= { set = "Trapper of Foes" },
		["Heightened Senses"]						= { set = "Trapper of Foes" },
		["Heart of the Bard"]						= { set = "Trapper of Foes" },
		["Stealthy Shot"]							= { set = "Trapper of Foes" },

		["Earthborn"]								= { set = "Huntsman" },
		["Deadly Precision"]						= { set = "Huntsman" },
		["Swift Recovery"]							= { set = "Huntsman",
														cooldown = { ["Needful Haste"] = "-30s", ["Intent Concentration"] = "-30s" } },
		["Strong Draw"]								= { set = "Huntsman" },
		["Arrow Storm"]								= { set = "Huntsman" },
		["Resolute Aim"]							= { set = "Huntsman" },
		["Deep Concentration"]						= { set = "Huntsman" },
		["Rapid Recovery"]							= { set = "Huntsman",
														cooldown = {
															["Agile Rejoinder"] = "-2s",
															["Blindside"] = "-2s",
															["Dazing Blow"] = "-10s",
															["Low Cut"] = "-2s",
															["Scourging Blow"] = "-2s",
															["Swift Stroke"] = "-2s"
														}
													  },

		["Bow of the Righteous"]					= { set = "Legendary" },
		["Rain of Thorns"]							= { set = "Legendary", enable = { "Rain of Thorns" } },
		["Bards Arrow"]								= { set = "Legendary", enable = { "Bards Arrow" } },
		["Press Onward"]							= { set = "Legendary", enable = { "Press Onward" } },
		["Cool Burn"]								= { set = "Legendary", cooldown = { ["Burn Hot"] = "-180s" } },
		["Explosive Arrow"]							= { set = "Legendary", cooldown = { ["Distracting Shot"] = "-150s" } },
		["Improved Fleetness"]						= { set = "Legendary", enable = { "+Improved Fleetness" } },

		["Bowmaster"]								= { set = "Set",
														[4] = { cooldown = { ["Heart Seeker"] = "-60s" } },
													  },
		["Trapper of Foes"]							= { set = "Set",
														[2] = { induction = { ["Set Trap"] = "-50%", ["Set Snare"] = "-50%" } },
														[3] = { cooldown = { ["Set Trap"] = "-30s", ["Set Snare"] = "-30s" } },
														[4] = { cooldown = { ["Purge Poison"] = "+10s" } }
													  },
		["Huntsman"]								= { set = "Set",
														[3] = { skills = HunterRangedSkills, induction = "-10%" },
														[4] = { skills = HunterRangedSkills, induction = "-10%" },
														[5] = { skills = HunterRangedSkills, induction = "-2%" },
														[6] = { skills = HunterRangedSkills, induction = "-2%" },
														[7] = { skills = HunterRangedSkills, induction = "-2%" }
													  }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Dunadan Learning"]						= { set = "Keeper of Animals",
														cooldown = {
															["Sign of Power: Righteousnes"]					= "-2s"
														}
													  },
		["Master of Beasts"]						= { set	= "Keeper of Animals" },
		["Improved Flanking"]						= { set = "Keeper of Animals" },
		["Hardy Companion"]							= { set = "Keeper of Animals" },
		["Light of Hope"]							= { set = "Keeper of Animals",
														skills = { "Beacon of Hope" },
														induction = "-1s",
														cooldown = "-10s"
													  },
		["Healer"]									= { set = "Keeper of Animals",
														skills = {
															"Knowledge of Cures",
															"Tend the Sick",
															"Beacon of Hope",
															"Inner Flame",
															"Share the Power"
														},
														induction = "-50%"
													  },
		["Proof Against All Ills"]					= { set = "Keeper of Animals" },
		["Improved Inner Flame"]					= { set = "Keeper of Animals" },

		["Flame of Anor"]							= { set = "Master of Natures Fury" },
		["Tactically Adept"]						= { set = "Master of Natures Fury",
													    induction = {
															["Sticky Gourd"]								= "-50%"
														}
													  },
		["Master of the Staff"]						= { set = "Master of Natures Fury" },
		["Harmony With Nature"]						= { set = "Master of Natures Fury",
														skills = {
															"Burning Embers",
															"Cracked Earth",
															"Ents Go To War",
															"Gust of Wind",
															"Light of the Rising Dawn",
															"Lightning Storm"
														},
														induction = "-25%"
													  },
		["Awareness of Body"]						= { set = "Master of Natures Fury" },
		["Knowledge of the Past"]					= { set = "Master of Natures Fury" },
		["Improved Sign of Battle"]					= { set = "Master of Natures Fury" },
		["Knowledge of Storms"]						= { set = "Master of Natures Fury" },

		["Deep Lore"]								= { set = "Ancient Master" },
		["Power and Wisdom"]						= { set = "Ancient Master",
													    cooldown = {
															["Power of Knowledge"]							= "-10s"
														}
													  },
		["Fast Loader"]								= { set = "Ancient Master",
													    induction = {
															["Blinding Flash"]								= "-1s"
														}
													  },
		["Secret of Tar"]							= { set = "Ancient Master",
														skills = { "Sticky Tar" },
														induction = "-50%",
														cooldown = "-30s"
													  },
		["Study of Wind Lore"]						= { set = "Ancient Master" },
		["Study of Fire Lore"]						= { set = "Ancient Master" },
		["Improved Sign of Power: Command"]			= { set = "Ancient Master" },
		["Study of Frost Lore"]						= { set = "Ancient Master" },

		["March of the Ents"]						= { set = "Legendary", enable = { "Ents Go To War" } },
		["Sword and Staff"]							= { set = "Legendary" },
		["Noble Savage"]							= { set = "Legendary" },
		["Eagle Friend"]							= { set = "Legendary" },
		["Nature Friend"]							= { set = "Legendary", enable = { "Friend of Nature", "Combat Summoning" } },
		["Improved Sticky Gourd"]					= { set = "Legendary" },
		["Force of Will"]							= { set = "Legendary" },

		["Keeper of Animals"]						= { set = "Set",
														[3] = { cooldown = { ["Knowledge of Cures"] = "-5s" } },
														[4] = { cooldown = { ["Inner Flame"] = "-60s" } }
													  },
		["Master of Natures Fury"]					= { set = "Set",
														[3] = { cooldown = { ["Ents Go To War"] = "-180s" } },
														[4] = { cooldown = { ["Light of the Rising Dawn"] = "-15s" } }
													  },
		["Ancient Master"]							= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["Life Singer"]								= { set = "Watcher of Resolve" },
		["Silver Tongue"]							= { set = "Watcher of Resolve" },
		["Focused Performance"]						= { set = "Watcher of Resolve",
														skills = {
															"War-speech",
															"Raise the Spirit",
															"Inspire Fellows",
															"Bolster Courage",
															"Enlivening Grace",
															"Rally!",
															"Fellowship's Heart",
															"Song of the Dead",
															"Song of Soothing",
															"Song of Distration",
															"Symphony of the Hopeful Heart",
															"Song of Restoration",
															"Tale of Heroism",
															"Story of Courage",
															"Tale of Battle",
															"Tale of Warding",
															"Tale of Frost and Flame",
															"Tale of Frost and Flames Battle",
															"Tale of Warding and Heroism",
															"Harmony"
														},
														induction = "-10%"
													  },
		["Graceful Demeanour"]						= { set = "Watcher of Resolve",
													    cooldown = { ["Rally!"] = "-300s" },
														induction = { ["Enlivening Grace"] = "-2s", ["Rally!"] = "-2s" }
													  },
		["Subtle Movements"]						= { set = "Watcher of Resolve" },
		["Improved Song of Soothing"]				= { set = "Watcher of Resolve",
														skills = { "Song of Soothing" },
														induction = "-100%"
													  },
		["Improved Raise the Spirit"]				= { set = "Watcher of Resolve",
														skills = { "Raise the Spirit" },
														cooldown = "-1.5s",
														induction = "-50%"
													  },
		["Power of Song"]							= { set = "Watcher of Resolve" },

		["Glorious Anthem"]							= { set = "Protector of Song" },
		["Absolute Pitch"]							= { set = "Protector of Song" },
		["Heralded Saviour"]						= { set = "Protector of Song" },
		["Smooth Voice"]							= { set = "Protector of Song",
														skills = {
															"Anthem of Prowess",
															"Anthem of War",
															"Anthem of Composure",
															"Anthem of the Free Peoples",
															"Anthem of Compassion",
															"Anthem of the Third Age"
														},
														cooldown = "-5s"
													  },
		["Flow of Harmony"]							= { set = "Protector of Song" },
		["Battle Hymn"]								= { set = "Protector of Song" },
		["Lyrics of Bravery"]						= { set = "Protector of Song" },
		["Heralded Resolve"]						= { set = "Protector of Song" },

		["Discordant Melody"]						= { set = "Warrior Skald" },
		["Powerful Voice"]							= { set = "Warrior Skald" },
		["Light in the Dark"]						= { set = "Warrior Skald" },
		["Unrelenting"]								= { set = "Warrior Skald" },
		["Heralds Hammer"]							= { set = "Warrior Skald" },
		["Armour of Song"]							= { set = "Warrior Skald" },
		["Improved Echoes of Battle"]				= { set = "Warrior Skald" },
		["Enduring Morale"]							= { set = "Warrior Skald" },

		["Rally"]									= { set = "Legendary", enable = { "Rally!" } },
		["Symphony of the Hopeful Heart"]			= { set = "Legendary", enable = { "Symphony of the Hopeful Heart" } },
		["Cry of the Wizards"]						= { set = "Legendary", enable = { "Cry of the Wizards" } },
		["Fellowships Heart"]						= { set = "Legendary", enable = { "Fellowships Heart" } },
		["Legendary Spirit"]						= { set = "Legendary" },
		["Master of Tales"]							= { set = "Legendary", enable = { "Tale of Frost and Flames Battle", "Tale of Warding and Heroism" } },
		["Call of War"]								= { set = "Legendary" },

		["Watcher of Resolve"]						= { set = "Set" },
		["Protector of Song"]						= { set = "Set",
														[2] = { cooldown = { ["Call to Greatness"] = "-20s" } },
														[3] = {
															skills = {
																"Anthem of Prowess",
																"Anthem of War",
																"Anthem of Composure",
																"Anthem of the Free Peoples",
																"Anthem of Compassion",
																"Anthem of the Third Age"
															},
															cooldown = "-5s"
														},
														[4] = {
															skills = {
																"Anthem of Prowess",
																"Anthem of War",
																"Anthem of Composure",
																"Anthem of the Free Peoples",
																"Anthem of Compassion",
																"Anthem of the Third Age"
															},
															cooldown = "-5s"
														}
													  },
		["Warrior Skald"]							= { set = "Set",
														[3] = {
															cooldown = {
																["Cry of the Valar"] = "-30s",
																["Cry of the Wizards"] = "-30s"
															}
														}
													  }
	},

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Thunderous Words"]						= { set = "Solitary Thunder" },
		["Harsh Debate"]							= { set = "Solitary Thunder" },
		["Closing Remarks"]							= { set = "Solitary Thunder", cooldown = { ["Epic Conclusion"] = "-60s" } },
		["Tale of the Storm"]						= { set = "Solitary Thunder" },
		["Winter Storm"]							= { set = "Solitary Thunder" },
		["Icy Discourse"]							= { set = "Solitary Thunder" },
		["Confounding Principles"]					= { set = "Solitary Thunder" },
		["Mastery of Tragedy"]						= { set = "Solitary Thunder" },

		["Conflagration of Runes"]					= { set = "Cleansing Fires" },
		["Writ of Blazing Fire"]					= { set = "Cleansing Fires", cooldown = { ["Writ of Fire"] = "-2s" } },
		["Scathing Retort"]							= { set = "Cleansing Fires" },
		["Tale of Rage"]							= { set = "Cleansing Fires" },
		["Frost Burn"]								= { set = "Cleansing Fires", cooldown = { ["Writ of Cold"] = "-2s" } },
		["Overwhelming Confidence"]					= { set = "Cleansing Fires"	},
		["Linnod of Subtlety"]						= { set = "Cleansing Fires" },
		["Master of Connotation"]					= { set = "Cleansing Fires" },

		["Memorable Prose"]							= { set = "Benedictions of Peace" },
		["Writ of Well Being"]						= { set = "Benedictions of Peace", cooldown = { ["Writ of Health"] = "-2s" } },
		["Author of Exaltation"]					= { set = "Benedictions of Peace" },
		["Terse Narrative"]							= { set = "Benedictions of Peace",
													    enable = { "+Terse Narrative" },
														skills = { "Epic for the Ages" }, induction = "-0.5s", cooldown = "-3s"
													  },
		["Rune of Endurance"]						= { set = "Benedictions of Peace" },
		["Prophetic Word"]							= { set = "Benedictions of Peace",
														skills = {
															"Do Not Fall to Storm",
															"Fall to our Wrath",
															"Fall to Storm",
															"Shall Not Fall This Day",
															"Blade will not Wound",
															"Fang will not Poison"
														},
														cooldown = "-20%"
													  },
		["Linnod of Peace"]							= { set = "Benedictions of Peace", induction = { ["Calming Verse"] = "-100%" } },
		["Master of Allusion"]						= { set = "Benedictions of Peace" },

		["Steady Hands"]							= { set = "Legendary", enable = { "Steady Hands" } },
		["You Shall Fall to our Wrath"]				= { set = "Legendary", enable = { "Fall to our Wrath" } },
		["That Which Does Not Kill Us"]				= { set = "Legendary", enable = { "That Which Does Not Kill Us" } },
		["Martial Training"]						= { set = "Legendary" },
		["Perfect Imagery"]							= { set = "Legendary", cooldown = { ["Vivid Imagery"] = "-120s" } },
		["Mystifying Flame"]						= { set = "Legendary", cooldown = { ["Distracting Flame"] = "-30s" } },
		["Wondrous Foreshadowing"]					= { set = "Legendary", cooldown = { ["Glorious Foreshadowing"] = "-60s" } },

		["Solitary Thunder"]						= { set = "Set",
														[2] = { cooldown = { ["Chilling Rhetoric"] = "-10s" } },
														[3] = { cooldown = { ["Shocking Words"] = "-5s" } }
													  },
		["Cleansing Fires"]							= { set = "Set",
														[2] = { induction = { ["Fiery Ridicule"] = "-0.5s" } },
														[4] = { induction = { ["Essay of Fire"] = "-4.5s" } }
													  },
		["Benedictions of Peace"]					= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Warden] = {
		["Skill and Power"]							= { set = "!Way of the Spear" },
		["Efficient Thrust"]						= { set = "!Way of the Spear" },
		["Find Weakness"]							= { set = "!Way of the Spear" },
		["Veteran"]									= { set = "!Way of the Spear" },
		["Expert Hurler"]							= { set = "!Way of the Spear",
														cooldown = {
															["Ambush"] = "-15s",
															["Hampering Javelin"] = "-15s",
															["Javelin of Deadly Force"] = "-15s",
															["Shield Piercer"] = "-15s",
															["Wages of Fear"] = "-15s"
														}
													  },
		["Mighty Throw"]							= { set = "!Way of the Spear" },
		["Deadly Thrust"]							= { set = "!Way of the Spear" },
		["Master of the Spear"]						= { set = "!Way of the Spear", enable = { "Spear and Spear" } },

		["Wary Blocks"]								= { set = "!Way of the Shield" },
		["Shield Trickery"]							= { set = "!Way of the Shield" },
		["Perseverance"]							= { set = "!Way of the Shield" },
		["Skillful Blocking"]						= { set = "!Way of the Shield" },
		["Never Say Die"]							= { set = "!Way of the Shield" },
		["Efficient Shieldwork"]					= { set = "!Way of the Shield" },
		["Ward of Justice"]							= { set = "!Way of the Shield" },
		["Master of the Shield"]					= { set = "!Way of the Shield", enable = { "Shield and Shield" } },

		["Know Your Enemy"]							= { set = "!Way of the Fist" },
		["Deadly Insult"]							= { set = "!Way of the Fist" },
		["Strong Voice"]							= { set = "!Way of the Fist" },
		["Terrible Visage"]							= { set = "!Way of the Fist" },
		["Confidence"]								= { set = "!Way of the Fist" },
		["A Keen Response"]							= { set = "!Way of the Fist" },
		["Force of Personality"]					= { set = "!Way of the Fist" },
		["Master of the Fist"]						= { set = "!Way of the Fist", enable = { "Fist and Fist" } },

		["Grand Master Weapons Training"]			= { set = "Legendary" },
		["Defiant Challenge"]						= { set = "Legendary" },
		["Way of the Warden"]						= { set = "Legendary",
														enable = {
															"Way of the Warden",
															"Spear and Shield",
															"Spear and Fist",
															"Shield and Spear",
															"Shield and Fist",
															"Fist and Spear",
															"Fist and Shield"
													    }
													  },
		["Javelin of Deadly Force"]					= { set = "Legendary", enable = { "Javelin of Deadly Force" } },
		["Way of the Spear"]						= { set = "Legendary" },
		["Way of the Shield"]						= { set = "Legendary" },
		["Way of the Fist"]							= { set = "Legendary" },

		["!Way of the Spear"]						= { set = "Set" },
		["!Way of the Shield"]						= { set = "Set" },
		["!Way of the Fist"]						= { set = "Set" }
	}
};

legacyTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["Aim Cooldown"]							= { skills = { "Aim" }, type = "cooldownmod" },
		["Addle Cooldown"]							= { skills = { "Addle" }, type = "cooldownmod" },
		["Feint Attack Cooldown"]					= { skills = { "Feint Attack" }, type = "cooldownmod" },
		["Hide in Plain Sight Cooldown"]			= { skills = { "Hide in Plain Sight" }, type = "cooldownmod" },
		["Location is Everything Cooldown"]			= { skills = { "Location is Everything" }, type = "cooldownmod" },
		["Lucky Strike Cooldown"]					= { skills = { "Lucky Strike" }, type = "cooldownmod" },
		["Ready and Able Cooldown"]					= { skills = { "Ready and Able" }, type = "cooldownmod" },
		["Small Snag Cooldown"]						= { skills = { "A Small Snag" }, type = "cooldownmod" },
		["Well Placed Strike Cooldown"]				= { skills = { "Well Placed Strike" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.Captain] = {
		["Kick Cooldown"]							= { skills = { "Kick" }, type = "cooldownmod" },
		["Rallying Cry Cooldown"]					= { skills = { "Rallying Cry" }, type = "cooldownmod" },
		["Time of Need Cooldown"]					= { skills = { "Time of Need" }, type = "cooldownmod" },
		["Escape from Darkness Cooldown"]			= { skills = { "Escape from Darkness" }, type = "cooldownmod" },
		["Muster Courage Cooldown"]					= { skills = { "Muster Courage" }, type = "cooldownmod" },
		["Grave Wound Cooldown"]					= { skills = { "Grave Wound" }, type = "cooldownmod" },
		["Shield of Dunedain Cooldown"]				= { skills = { "Shield of Dunedain" }, type = "cooldownmod" },
		["Shadows Lament Cooldown"]					= { skills = { "Shadows Lament" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.Champion] = {
		["Ferocious Strikes Cooldown"]				= { skills = { "Ferocious Strikes" }, type = "cooldownmod" },
		["Battle Frenzy Cooldown"]					= { skills = { "Battle Frenzy" }, type = "cooldownmod" },
		["Fear Nothing Cooldown"]					= { skills = { "Fear Nothing!" }, type = "cooldownmod" },
		["Ebbing Ire Cooldown"]						= { skills = { "Ebbing Ire" }, type = "cooldownmod" },
		["Dire Need Cooldown"]						= { skills = { "Dire Need" }, type = "cooldownmod" },
		["Rising Ire Cooldown"]						= { skills = { "Rising Ire" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.Guardian] = {
		["Guardians Pledge Cooldown"]				= { skills = { "Guardians Pledge" }, type = "cooldownmod" },
		["Stamp Cooldown"]							= { skills = { "Stamp" }, type = "cooldownmod" },
		["Turn the Tables Cooldown"]				= { skills = { "Turn the Tables" }, type = "cooldownmod" },
		["Catch a Breath Cooldown"]					= { skills = { "Catch a Breath" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["Desperate Flight Cooldown"]				= { skills = { "Desperate Flight" }, type = "cooldownmod" },
		["Distracting Shot Cooldown"]				= { skills = { "Distracting Shot" }, type = "cooldownmod" },
		["Merciful Shot Cooldown"]					= { skills = { "Merciful Shot" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Staff Strike Cooldown"]					= { skills = { "Staff Strike" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["Cure Fear"]								= { skills = { "Cure Fear" }, type = "cooldownmod" },
		["Rally Cooldown"]							= { skills = { "Rally!" }, type = "cooldownmod" },
		["Still as Death Cooldown"]					= { skills = { "Still as Death" }, type = "cooldownmod" },
		["Triumphant Spirit Cooldown"]				= { skills = { "Triumphant Spirit" }, type = "cooldownmod" },
		["Cry of the Chorus Cooldown"]				= { skills = { "Cry of the Chorus" }, type = "cooldownmod" },
		["Song of the Dead Cooldown"]				= { skills = { "Song of the Dead" }, type = "cooldownmod" },
		["Chord of Salvation Cooldown"]				= { skills = { "Chord of Salvation" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Distracting Flame Cooldown"]				= { skills = { "Distracting Flame" }, type = "cooldownmod" },
		["Distracting Winds Cooldown"]				= { skills = { "Distracting Winds" }, type = "cooldownmod" },
		["Chilling Rhetoric Cooldown"]				= { skills = { "Chilling Rhetoric" }, type = "cooldownmod" },
		["Frozen Epilogue Cooldown"]				= { skills = { "Frozen Epilogue" }, type = "cooldownmod" },
		["Do Not Fall This Day Cooldown"]			= { skills = { "Do Not Fall This Day" }, type = "cooldownmod" },
		["Word of Exaltation Cooldown"]				= { skills = { "Word of Exaltation" }, type = "cooldownmod" }
	},

	[Turbine.Gameplay.Class.Warden] = { }
};

setTable = {
	[Turbine.Gameplay.Class.Burglar] = { },

	[Turbine.Gameplay.Class.Captain] = {
		["Helegrod"]								= {
														tiers = 6,
														[4] = {
															cooldown = {
																["Rallying Cry"] = "-20%",
																["Routing Cry"] = "-20%",
																["Shadow's Lament"] = "-20%",
																["War-cry"] = "-20%"
															},
														},
														[6] = { cooldown = { ["Escape from Darkness"] = "-300s" } }
													  }
	},

	[Turbine.Gameplay.Class.Champion] = { },

	[Turbine.Gameplay.Class.Guardian] = {
		["Helegrod"]								= {
														tiers = 6,
														[6] = { cooldown = { ["Challenge the Darkness"] = "-30%" } }
													  }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["Helegrod"]								= {
														tiers = 6,
														[4] = { cooldown = { ["Swift Bow"] = "-2.5s" } },
														[6] = { cooldown = { ["Penetrating Shot"] = "-1.5s" } }
													  }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Helegrod"]								= {
														tiers = 6,
														[4] = { cooldown = { ["Test of Will"] = "-20s" } }
													  }
	},

	[Turbine.Gameplay.Class.Minstrel] = { },

	[Turbine.Gameplay.Class.RuneKeeper] = { },

	[Turbine.Gameplay.Class.Warden] = { }
};

equipTable = {
	[Turbine.Gameplay.Class.Burglar] = { },

	[Turbine.Gameplay.Class.Captain] = { },

	[Turbine.Gameplay.Class.Champion] = { },

	[Turbine.Gameplay.Class.Guardian] = { },

	[Turbine.Gameplay.Class.Hunter] = { },

	[Turbine.Gameplay.Class.LoreMaster] = { },

	[Turbine.Gameplay.Class.Minstrel] = { },

	[Turbine.Gameplay.Class.RuneKeeper] = { },

	[Turbine.Gameplay.Class.Warden] = { }
};

buffTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["+Mischief"]								= { [1] = { cooldown = { ["Riddle"] = "-30s" } } }
	},

	[Turbine.Gameplay.Class.Captain] = { },

	[Turbine.Gameplay.Class.Champion] = { },

	[Turbine.Gameplay.Class.Guardian] = { },

	[Turbine.Gameplay.Class.Hunter] = {
		["+Improved Fleetness"]						= { skills = HunterRangedSkills, [1] = { induction = "-15%" } },
		["+Needful Haste"]							= { [1] = { induction = { ["Barbed Arrow"] = "-0.25s", ["Swift Bow"] = "-0.5s" } } }
	},

	[Turbine.Gameplay.Class.LoreMaster] = { },

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["+Terse Narrative"]						= { skills = { "Epic for the Ages" }, [1] = { induction = "-0.5s" } },
		["+Essay of Fire"]							= { skills = {
															"Distracting Flame",
															"Essay of Fire",
															"Essence of Flame",
															"Fiery Ridicule",
															"Scathing Mockery",
															"Smoldering Wrath",
															"Writ of Fire"
														},
														[1] = { induction = "-100%" }
													  }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["+Anthem of the Third Age"]				= { skills = {
															"War-speech",
															"Raise the Spirit",
															"Inspire Fellows",
															"Bolster Courage",
															"Enlivening Grace",
															"Rally!",
															"Fellowship's Heart",
															"Song of the Dead",
															"Song of Soothing",
															"Song of Distration",
															"Symphony of the Hopeful Heart",
															"Song of Restoration",
															"Tale of Heroism",
															"Story of Courage",
															"Tale of Battle",
															"Tale of Warding",
															"Tale of Frost and Flame",
															"Tale of Frost and Flames Battle",
															"Tale of Warding and Heroism",
															"Harmony"
														},
														[1] = { induction = "-25%" }
													  }
	},
	

	[Turbine.Gameplay.Class.Warden] = {
		["+Careful Step"]							= { [1] = { induction = { ["Ambush"] = "-100%" } } }
	}
};

classSkillTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["Clever Retort"]							= { induction = 0.0, cooldown = 120.0, shortcut = "0x7000D440" },
		["Startling Twist"]							= { induction = 0.0, cooldown =  45.0, shortcut = "0x70028383" },
		["Mischief"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000D4A4", sharedCooldown = { "Gambler", "Quiet Knife" } },
		["Mischievous Glee"]						= { induction = 0.0, cooldown =  45.0, shortcut = "0x70020DD0", alias = { "Mischievous Delight" } },
		["Trick: Counter Defence"]					= { induction = 0.0, cooldown =   5.0, shortcut = "0x7002837A", alias = { "Trick: Improved Counter Defence" } },
		["Trick: Disable"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x700031FA" },
		["Trick: Dust in the Eyes"]					= { induction = 0.0, cooldown =   5.0, shortcut = "0x700031E7" },
		["Trick: Enrage"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003218" },

		["Cunning Attack"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F09" },
		["Diversion"]								= { induction = 0.0, cooldown =  20.0, shortcut = "0x700031F5" },
		["Hide in Plain Sight"]						= { induction = 0.0, cooldown = 600.0, shortcut = "0x70015A02" },
		["Location is Everything"]					= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000D445" },
		["Provoke"]									= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F0A" },
		["Quiet Knife"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x7002613C", sharedCooldown = { "Gambler", "Mischief" } },
		["Share the Fun"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000D448" },
		["Sneak"]									= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003212", sharedCooldown = { "Sneak" } },
		["Surprise Strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003F08", sharedCooldown = { "Share the Fun" } },
		["Trip"]									= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003F07", alias = { "Tangle-foot" } },

		["A Small Snag"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000FB73", alias = { "Quite a Snag" } },
		["Addle"]									= { induction = 0.0, cooldown =  15.0, shortcut = "0x70003F0E" },
		["Aim"]										= { induction = 0.0, cooldown =  90.0, shortcut = "0x700031E1" },
		["Burglar's Advantage"]						= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F0B" },
		["Confound"]								= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000D441" },
		["Double-edged Strike"]						= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F0C" },
		["Exploit Opening"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003F0D" },
		["Exposed Throat"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70000F80" },
		["Feint Attack"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000FB71" },
		["Flashing Blades"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70000F5D" },
		["Gambler"]									= { induction = 0.0, cooldown =  10.0, shortcut = "0x7002613B", sharedCooldown = { "Mischief", "Quiet Knife" } },
		["Knives Out"]								= { induction = 0.0, cooldown = 120.0, shortcut = "0x7000D444" },
		["Lucky Strike"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000FD86", alias = { "Gambler's Strike" } },
		["Reveal Weakness"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F11" },
		["Riddle"]									= { induction = 0.0, cooldown =  60.0, shortcut = "0x70028385" },
		["Subtle Stab"]								= { induction = 0.0, cooldown =   3.0, shortcut = "0x7002837D" },
		["Well Placed Strike"]						= { induction = 3.0, cooldown = 180.0, shortcut = "0x7000D43E" },

		["Burglar's Antidote"]						= { induction = 0.5, cooldown =  60.0, shortcut = "0x7001F4A4" },
		["Burgle"]									= { induction = 0.0, cooldown =  20.0, shortcut = "0x70003F16" },
		["Contact Pedlar"]							= { induction = 0.0, cooldown =1800.0, shortcut = "0x7000D442" },
		["Escape Clause"]							= { induction = 0.0, cooldown = 600.0, shortcut = "0x7000D443" },
		["Find Footing"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003F14" },
		["Ready and Able"]							= { induction = 0.0, cooldown =1800.0, shortcut = "0x70003F12" },
		["Safe Fall"]								= { induction = 0.0, cooldown =  60.0, shortcut = "0x7002613D" },
		["Touch and Go"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003F13" }
	},

	[Turbine.Gameplay.Class.Captain] = {
		["Escape from Darkness"]					= { induction = 4.0, cooldown =1800.0, shortcut = "0x70002F45" },
		["In Harms Way"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003E58", power = 0.10 },
		["Inspire"]									= { induction = 0.0, cooldown =  15.0, shortcut = "0x7000A1D7" },
		["Muster Courage"]							= { induction = 0.0, cooldown =  30.0, shortcut = "0x70002F99" },
		["Shield of the Dunedain"]					= { induction = 0.0, cooldown = 300.0, shortcut = "0x700012F9" },
		["Valiant Strike"]							= { induction = 0.0, cooldown = 120.0, shortcut = "0x7000FF6D" },
		["Words of Courage"]						= { induction = 0.0, cooldown =   3.0, shortcut = "0x70003E51" },

		["Cry of Vengeance"]						= { induction = 0.0, cooldown =1800.0, shortcut = "0x70003E57" },
		["Make Haste"]								= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003E4E" },
		["Noble Mark"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003E4F", power = 0.03 },
		["Oathbreaker's Shame"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x70001306" },
		["Rallying Cry"]							= { induction = 0.0, cooldown =  45.0, shortcut = "0x70002F4F" },
		["Revealing Mark"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003E56", power = 0.03 },
		["Routing Cry"]								= { induction = 0.0, cooldown =  45.0, shortcut = "0x70002F61" },
		["Telling Mark"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003E4D", power = 0.03 },
		["War-cry"]									= { induction = 0.0, cooldown =  45.0, shortcut = "0x70002F58" },

		["Battle Shout"]							= { induction = 0.0, cooldown =  20.0, shortcut = "0x70002F67" },
		["Cutting Attack"]							= { induction = 0.0, cooldown =  20.0, shortcut = "0x70028FA5" },
		["Devastating Blow"]						= { induction = 0.0, cooldown =   4.2, shortcut = "0x70002FCF" },
		["Grave Wound"]								= { induction = 0.0, cooldown =  30.0, shortcut = "0x70028E4B" },
		["Blade of Elendil"]						= { induction = 0.0, cooldown =   4.2, shortcut = "0x70017D31" },
		["Defensive Strike"]						= { induction = 0.0, cooldown =   3.0, shortcut = "0x7000FF86" },
		["Kick"]									= { induction = 0.0, cooldown =  60.0, shortcut = "0x7000AA0E" },
		["Last Stand"]								= { induction = 0.0, cooldown = 900.0, shortcut = "0x70003E54" },
		["Pressing Attack"]							= { induction = 0.0, cooldown =   4.2, shortcut = "0x70003E50" },
		["Shadow's Lament"]							= { induction = 0.0, cooldown =  45.0, shortcut = "0x7000FF8B" },
		["Sure Strike"]								= { induction = 0.0, cooldown =   6.0, shortcut = "0x70028DB4" },
		["Threatening Shout"]						= { induction = 0.0, cooldown =  20.0, shortcut = "0x70002FD5" },

		["Call to Arms: Archer"]					= { induction = 3.0, cooldown =   0.0, shortcut = "0x7000FC78" },
		["Call to Arms: Herald of Hope"]			= { induction = 3.0, cooldown =   0.0, shortcut = "0x70002FAF" },
		["Call to Arms: Herald of Victory"]			= { induction = 3.0, cooldown =   0.0, shortcut = "0x70002F1A" },
		["Call to Arms: Herald of War"]				= { induction = 3.0, cooldown =   0.0, shortcut = "0x70002F7A" },
		["Fighting Withdrawl"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x7001F4C9" },
		["In Defense of Middle Earth"]				= { induction = 0.0, cooldown =   0.0, shortcut = "0x7000130D" },
		["Motivating Speech"]						= { induction = 0.0, cooldown =   3.0, shortcut = "0x70003E52" },
		["Strength of Will"]						= { induction = 0.0, cooldown = 120.0, shortcut = "0x7000B058" },
		["Tactics: Focus"]							= { induction = 0.0, cooldown =   1.5, shortcut = "0x70003E59" },
		["Tactics: On Guard"]						= { induction = 0.0, cooldown =   1.5, shortcut = "0x70003E53" },
		["Tactics: Relentless Attack"]				= { induction = 0.0, cooldown =   1.5, shortcut = "0x70003E55" },
		["Time of Need"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000AA12", power = 0.00 },
		["To Arms"]									= { induction = 0.0, cooldown =  60.0, shortcut = "0x7000AA0D" },
		["Shield-brother"]							= { induction = 0.0, cooldown =   3.0, shortcut = "0x70020DF6", power = 0.00, alias = { "Watchful Shield-brother" } },
		["Song-brother"]							= { induction = 0.0, cooldown =   3.0, shortcut = "0x70028EFB", power = 0.00 },
		["Blade-brother"]							= { induction = 0.0, cooldown =   3.0, shortcut = "0x70028EFF", power = 0.00 }

	},

	[Turbine.Gameplay.Class.Champion] = {
		["Battle-frenzy"]							= { induction = 0.0, cooldown =  60.0, shortcut = "0x70003043" },
		["Merciful Strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003E09" },
		["Swift Strike"]							= { induction = 0.0, cooldown =   3.2, shortcut = "0x7000300F" },
		["Wild Attack"]								= { induction = 0.0, cooldown =   1.8, shortcut = "0x70003DFC" },

		["Second Wind"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000D47A", power = 0.00 },
		["Sprint"]									= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003E0B", power = 0.00 },
		["Seeking Blade"]							= { induction = 0.0, cooldown = 120.0, shortcut = "0x70028FC6" },
		["Blood Rage"]								= { induction = 0.0, cooldown =   1.0, shortcut = "0x7000F70E", power = 0.00 },
		["True Heroics"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70020DF3", power = 0.30 },
		["Continuous Blood Rage"]					= { induction = 0.0, cooldown =   1.0, shortcut = "0x7000F70A", power = 0.00 },

		["Let Fly"]									= { induction = 0.9, cooldown =   9.0, shortcut = "0x70003E14" },
		
		["Blade-wall"]								= { induction = 0.0, cooldown =   4.2, shortcut = "0x70003DFD" },
		["Flurry"]									= { induction = 0.0, cooldown =  12.0, shortcut = "0x70003E00" },
		["Blade-storm"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003E03" },
		["Ardour"]									= { induction = 0.0, cooldown =   4.2, shortcut = "0x7000D46C", power = 0.00, sharedCooldown = { "Fervour", "Glory" } },
		["Battle Acuity"]							= { induction = 0.0, cooldown =  30.0, shortcut = "0x7002A77B", alias = { "Enhanced Battle Acuity" } },
		["Horn of Gondor"]							= { induction = 0.0, cooldown =  20.0, shortcut = "0x70003E0D" },
		["Raging Blades"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70002DA9" },
		["Rend"]									= { induction = 0.0, cooldown =   4.2, shortcut = "0x7000F660" },
		["Great Cleave"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000F70C" },

		["Exchange of Blows"]						= { induction = 0.0, cooldown =   0.0, shortcut = "0x70003E02" },
		["Bracing Attack"]							= { induction = 0.0, cooldown =  30.0, shortcut = "0x70003E04" },
		["Sudden Defence"]							= { induction = 0.0, cooldown = 180.0, shortcut = "0x70003E06", power = 0.00 },
		["Champion's Challenge"]					= { induction = 0.0, cooldown =  30.0, shortcut = "0x70003E08" },
		["Glory"]									= { induction = 0.0, cooldown =   4.2, shortcut = "0x7000967C", power = 0.00, sharedCooldown = { "Fervour", "Ardour" } },
		["Dire Need"]								= { induction = 0.0, cooldown = 600.0, shortcut = "0x7002A5E2" },
		["Hedge"]									= { induction = 0.0, cooldown = 180.0, shortcut = "0x7002A774" },
		["Fight On"]								= { induction = 0.0, cooldown = 300.0, shortcut = "0x70002D9D", power = 0.00 },
		["Adamant"]									= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000F70B" },
		["Fear Nothing!"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70021D27" },
		
		["Fervour"]									= { induction = 0.0, cooldown =   4.2, shortcut = "0x70003DFF", power = 0.00, sharedCooldown = { "Ardour", "Glory" } },
		["Brutal Strikes"]							= { induction = 0.0, cooldown =   4.2, shortcut = "0x70003E01" },
		["Clobber"]									= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003E0C" },
		["Hamstring"]								= { induction = 0.0, cooldown =   4.2, shortcut = "0x70003E0E" },
		["Ferocious Strikes"]						= { induction = 0.0, cooldown =  14.0, shortcut = "0x70002D8D" },
		["Ebbing Ire"]								= { induction = 0.0, cooldown = 120.0, shortcut = "0x70009E5B" },
		["Red Haze"]								= { induction = 0.0, cooldown =   5.0, shortcut = "0x7000967D" },
		["Controlled Burn"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70002DB5", power = 0.00 },
		["Feral Strikes"]							= { induction = 0.0, cooldown =   4.2, shortcut = "0x7002907D" },
		["Remorseless Strike"]						= { induction = 0.0, cooldown =   1.8, shortcut = "0x7001F4B3" }
	},

	[Turbine.Gameplay.Class.Guardian] = {
		["Brutal Charge"]							= { induction = 0.0, cooldown = 120.0, shortcut = "0x7001F4B6" },
		["Guardian's Ward"]							= { induction = 0.0, cooldown =   3.0, shortcut = "0x700283E7", alias = { "Guardian's Ward Tactics" } },
		["Sting"]									= { induction = 0.0, cooldown =   6.2, shortcut = "0x7000F1E1" },
		["Salt the Wound"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x7000D4AF" },
		["Stamp"]									= { induction = 0.0, cooldown =  60.0, shortcut = "0x70003EE7" },
		["Sweeping Cut"]							= { induction = 0.0, cooldown =   9.0, shortcut = "0x70003EDE" },

		["Bash"]									= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003EE1" },
		["Catch a Breath"]							= { induction = 0.0, cooldown =  45.0, shortcut = "0x7000307D" },
		["Shield-smash"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x70002EC4" },
		["Shield-swipe"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x7000305D" },
		["Shield-taunt"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003EE6" },

		["Let Fly"]									= { induction = 0.9, cooldown =   9.0, shortcut = "0x70003E14" },

		["Challenge"]								= { induction = 0.0, cooldown =  45.0, shortcut = "0x70028B62" },
		["Challenge the Darkness"]					= { induction = 0.0, cooldown = 600.0, shortcut = "0x70002EDF" },
		["Engage"]									= { induction = 0.0, cooldown =  60.0, shortcut = "0x7000D4B2" },
		["Fray the Edge"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000D4B5" },
		["Shield-blow"]								= { induction = 0.0, cooldown =   3.5, shortcut = "0x7000F1E0" },
		["Litany of Defiance"]						= { induction = 0.0, cooldown =  20.0, shortcut = "0x7000F095" },
		["Vexing Blow"]								= { induction = 0.0, cooldown =   6.5, shortcut = "0x7000308A" },
		["Guardian's Threat"]						= { induction = 0.0, cooldown =   4.3, shortcut = "0x70002ED4", power = 0.00, sharedCooldown = { "Guardian's Defense", "Guardian's Parry", "Overpower" } },

		["Overpower"]								= { induction = 0.0, cooldown =   4.3, shortcut = "0x7000D4B1", power = 0.00, sharedCooldown = { "Guardian's Defense", "Guardian's Parry", "Guardian's Threat" } },
		["Brutal Assault"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x7000F158" },
		["Force Opening"]							= { induction = 0.0, cooldown =  21.0, shortcut = "0x7000D4B0" },
		["Stagger"]									= { induction = 0.0, cooldown =   5.0, shortcut = "0x7000D4B3" },

		["Overwhelm"]								= { induction = 0.0, cooldown =   5.0, shortcut = "0x70028414" },
		["Retaliation"]								= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003EE0" },
		["Thrust"]									= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003EE5" },
		["To the King"]								= { induction = 0.0, cooldown =   5.0, shortcut = "0x70002EA5" },
		["Whirling Retaliation"]					= { induction = 0.0, cooldown =   5.0, shortcut = "0x7002845C" },

		["Guardian's Defense"]						= { induction = 0.0, cooldown =   4.3, shortcut = "0x70028510", power = 0.00, sharedCooldown = { "Guardian's Parry", "Guardian's Threat", "Overpower" } },
		["Guardian's Parry"]						= { induction = 0.0, cooldown =   4.3, shortcut = "0x70003EE3", power = 0.00, sharedCooldown = { "Guardian's Defense", "Guardian's Threat", "Overpower" } },
		["Guardian's Pledge"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x700030A4" },
		["Protection"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000309A", power = 0.00, sharedCooldown = { "Shield Wall" }, alias = { "Protection by the Sword" } },
		["Summon Tinker"]							= { induction = 0.0, cooldown =1800.0, shortcut = "0x7000D4B4" },
		["Thrill of Danger"]						= { induction = 0.0, cooldown = 420.0, shortcut = "0x700030B4", power = 0.00 },
		["Deep Breath"]								= { induction = 0.0, cooldown = 900.0, shortcut = "0x700030A8", power = 0.00 },
		["Turn the Tables"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70028B82" },
		["Guardian's Promise"]						= { induction = 0.0, cooldown =  15.0, shortcut = "0x70003EE9", power = 0.00 },
		["Ignore the Pain"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70021663" },
		["Shield Wall"]								= { induction = 0.0, cooldown =  20.0, shortcut = "0x7000D4AE", sharedCooldown = { "Protection" } },
		["Take to Heart"]							= { induction = 0.0, cooldown = 120.0, shortcut = "0x7000ED87", power = 0.00 },
		["Warrior's Fortitude"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x70020DF5" }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["Agile Rejoinder"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003F3C" },
		["Blindside"]								= { induction = 0.0, cooldown =  20.0, shortcut = "0x70003F3B" },
		["Dazing Blow"]								= { induction = 0.0, cooldown =  60.0, shortcut = "0x70021D18" },
		["Low Cut"]									= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F39" },
		["Scourging Blow"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x70029859" },
		["Swift Stroke"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F38" },

		["Burn Hot"]								= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000F835", power = 0.20 },
		["Focus"]									= { induction = 0.0, cooldown =   2.0, shortcut = "0x70029854" },
		["Merciful Shot"]							= { induction = 0.0, cooldown =  30.0, shortcut = "0x700153E5" },
		["Intent Concentration"]					= { induction = 0.0, cooldown = 180.0, shortcut = "0x700030DE" },
		["Needful Haste"]							= { induction = 0.0, cooldown =  90.0, shortcut = "0x700030F3" },
		["Penetrating Shot"]						= { induction = 0.0, cooldown =   0.0, shortcut = "0x7002984F" },
		["Rain of Arrows"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003F36" },
		["Rain of Thorns"]							= { induction = 0.0, cooldown = 180.0, shortcut = "0x700010F4" },
		["Blood Arrow"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x70021D0D" },
		["Hunter's Art"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x7002958E" },

		["Bright Campfire"]							= { induction = 4.0, cooldown = 180.0, shortcut = "0x70003F3F" },
		["Camouflage"]								= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003F48" },
		["Cry of the Predator"]						= { induction = 0.0, cooldown =  60.0, shortcut = "0x70003F49" },
		["Passage of Foes"]							= { induction = 2.0, cooldown =  30.0, shortcut = "0x70003F46", sharedCooldown = { "Passage of Nature", "Passage of Shadow" } },
		["Passage of Nature"]						= { induction = 2.0, cooldown =  30.0, shortcut = "0x70003F45", sharedCooldown = { "Passage of Foes", "Passage of Shadow" } },
		["Passage of Shadow"]						= { induction = 2.0, cooldown =  30.0, shortcut = "0x70003F47", sharedCooldown = { "Passage of Foes", "Passage of Nature" } },
		["Purge Poison"]							= { induction = 0.0, cooldown =   0.0, shortcut = "0x70003F3E" },
		["Set Snare"]								= { induction = 2.5, cooldown =  60.0, shortcut = "0x7000A6B1", sharedCooldown = { "Set Trap" } },
		["Set Trap"]								= { induction = 2.5, cooldown =  60.0, shortcut = "0x700030BB", sharedCooldown = { "Set Snare" } },
		["Press Onward"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x700010E5", power = 0.00 },
		["Strength of the Earth"]					= { induction = 0.0, cooldown =  90.0, shortcut = "0x70010007", power = 0.00 },
		["Beneath Notice"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70020DF8", power = 0.00 },

		["Barbed Arrow"]							= { induction = 1.5, cooldown =   1.5, shortcut = "0x70003F33" },
		["Bards Arrow"]								= { induction = 1.5, cooldown =  30.0, shortcut = "0x700010D3" },
		["Distracting Shot"]						= { induction = 1.5, cooldown = 180.0, shortcut = "0x7000F9AB" },
		["Fleetness"]								= { induction = 0.0, cooldown =  30.0, shortcut = "0x70010065" },
		["Heart Seeker"]							= { induction = 3.0, cooldown = 120.0, shortcut = "0x7000A2D3" },
		["Swift Bow"]								= { induction = 2.0, cooldown =  10.0, shortcut = "0x700153E2" },
		["Quick Shot"]								= { induction = 1.0, cooldown =   0.0, shortcut = "0x70029856" },
		["Endurance"]								= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F4F", sharedCooldown = { "Precision", "Strength" } },
		["Precision"]								= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F4D", sharedCooldown = { "Endurance", "Strength" } },
		["Strength"]								= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003F4E", sharedCooldown = { "Endurance", "Precision" } },
		["Split Shot"]								= { induction = 1.5, cooldown =  10.0, shortcut = "0x700292DC" },

		["Desperate Flight"]						= { induction = 0.0, cooldown =1800.0, shortcut = "0x70003F40" },
		["Find the Path"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70003F3D" }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Knowledge of Cures"]						= { induction = 0.0, cooldown =  10.0, shortcut = "0x7001F45F" },

		["Eagle-friend"]							= { induction = 3.0, cooldown =   0.0, shortcut = "0x70000FB2" },
		["Friend of Bears"]							= { induction = 3.0, cooldown =   0.0, shortcut = "0x70003EB8" },
		["Friend of Feline Hunters"]				= { induction = 3.0, cooldown =   0.0, shortcut = "0x7000F530" },
		["Friend of Nature"]						= { induction = 3.0, cooldown =   0.0, shortcut = "0x7000F54D" },
		["Lynx-speech"]								= { induction = 3.0, cooldown =   0.0, shortcut = "0x7000B8D3" },
		["Raven-lore"]								= { induction = 3.0, cooldown =   0.0, shortcut = "0x70003EB5" },
		["Commune with Nature"]						= { induction = 3.0, cooldown =   0.0, shortcut = "0x7002A706" },
		["Combat Summoning"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x70024948", power = 0.00 },

		["Burning Embers"]							= { induction = 1.5, cooldown =   3.0, shortcut = "0x70028CA1" },
		["Cracked Earth"]							= { induction = 2.0, cooldown =  10.0, shortcut = "0x70003143" },
		["Ents Go To War"]							= { induction = 2.0, cooldown = 300.0, shortcut = "0x70000FA7" },
		["Gust of Wind"]							= { induction = 2.1, cooldown =  10.0, shortcut = "0x70003EB7" },
		["Light of the Rising Dawn"]				= { induction = 1.0, cooldown =  30.0, shortcut = "0x70003EC2" },
		["Lightning-storm"]							= { induction = 3.0, cooldown = 300.0, shortcut = "0x7000B726" },

		["Beacon of Hope"]							= { induction = 1.5, cooldown =  30.0, shortcut = "0x70003123" },
		["Inner Flame"]								= { induction = 0.0, cooldown = 180.0, shortcut = "0x70003EB6" },

		["Fire-lore"]								= { induction = 0.0, cooldown =  60.0, shortcut = "0x70003EBE" },
		["Frost-lore"]								= { induction = 0.0, cooldown =  60.0, shortcut = "0x70024BE7" },
		["Herb-lore"]								= { induction = 0.0, cooldown = 120.0, shortcut = "0x70003EC0" },
		["Knowledge of the Lore-master"]			= { induction = 2.0, cooldown =  60.0, shortcut = "0x7000C588" },
		["Storm-lore"]								= { induction = 0.0, cooldown = 120.0, shortcut = "0x7000B63C" },
		["Air-lore"]								= { induction = 1.0, cooldown =   5.0, shortcut = "0x70020DF7", power = 0.00, alias = { "Continual Air-lore" } },
		["Wind-lore"]								= { induction = 0.0, cooldown =  30.0, shortcut = "0x70003EBF" },

		["Power of Knowledge"]						= { induction = 0.0, cooldown =  60.0, shortcut = "0x70003116", power = 0.00 },
		["Ancient Craft"]							= { induction = 0.0, cooldown =  60.0, shortcut = "0x7000B627" },
		["Ancient Wisdom"]							= { induction = 3.0, cooldown =   0.0, shortcut = "0x7000315F" },
		["Back From the Brink"]						= { induction = 8.0, cooldown =   0.0, shortcut = "0x7000BFC2" },
		["Bane Flare"]								= { induction = 1.0, cooldown =  60.0, shortcut = "0x7000B60D" },
		["Blinding Flash"]							= { induction = 1.0, cooldown =  15.0, shortcut = "0x70003152" },
		["Call to the Valar"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003EC1" },
		["Dispel Corruption"]						= { induction = 0.0, cooldown =  30.0, shortcut = "0x7000F7FE" },
		["Share the Power"]							= { induction = 1.0, cooldown =   0.0, shortcut = "0x7000316B" },
		["Sticky Gourd"]							= { induction = 1.0, cooldown =  30.0, shortcut = "0x7000F74D" },
		["Sticky Tar"]								= { induction = 2.0, cooldown =  90.0, shortcut = "0x7000B62B" },
		["Test of Will"]							= { induction = 2.0, cooldown =  60.0, shortcut = "0x70003EB9" },
		["Warding Knowledge"]						= { induction = 2.0, cooldown =  60.0, shortcut = "0x7000B624" },
		["Wisdom of the Council"]					= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000314B", power = 0.00 },

		["Staff-strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000310D" },
		["Staff-sweep"]								= { induction = 0.0, cooldown =  15.0, shortcut = "0x70028B9A" },

		["Sign of Battle: Wizard's Fire"]			= { induction = 0.0, cooldown =   0.0, shortcut = "0x70028B52" },
		["Sign of Power: Command"]					= { induction = 0.0, cooldown =   1.8, shortcut = "0x70028B80" },
		["Sign of Power: Righteousnes"]				= { induction = 0.0, cooldown =   5.0, shortcut = "0x70003EBC" },
		["Sign of Power: See All Ends"]				= { induction = 0.0, cooldown =  60.0, shortcut = "0x7000F801" },
		["Sign of Power: Vigilance"]				= { induction = 0.0, cooldown =   3.0, shortcut = "0x70003EBD" },
		["Sign of the Wild: Protection"]			= { induction = 0.0, cooldown =  30.0, shortcut = "0x7000312B" },
		["Sign of the Wild: Rage"]					= { induction = 0.0, cooldown =  30.0, shortcut = "0x70028C98" }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["Anthem of Prowess"]						= { induction = 0.0, cooldown =  20.0, shortcut = "0x70003E7F" },
		["Anthem of War"]							= { induction = 0.0, cooldown =  20.0, shortcut = "0x7000317F" },
		["Anthem of Composure"]						= { induction = 0.0, cooldown =  20.0, shortcut = "0x70003E80" },
		["Anthem of the Free Peoples"]				= { induction = 0.0, cooldown =  20.0, shortcut = "0x70003E88" },
		["Anthem of Compassion"]					= { induction = 0.0, cooldown =  20.0, shortcut = "0x70003E8A" },
		["Anthem of the Third Age"]					= { induction = 0.0, cooldown =  20.0, shortcut = "0x700264BA" },

		["Major Ballad"]							= { induction = 0.0, cooldown =   1.0, shortcut = "0x70003E7C" },
		["Perfect Ballad"]							= { induction = 0.0, cooldown =   1.0, shortcut = "0x70003E7E" },
		["Minor Ballad"]							= { induction = 0.0, cooldown =   1.0, shortcut = "0x700031A8" },
		["Cry of the Chorus"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000F260" },

		["Melody of Battle"]						= { induction = 0.0, cooldown =   5.0, shortcut = "0x7000B697", alias = { "Timeless Echoes of Battle", "Echoes of Battle" } },
		["War-speech"]								= { induction = 5.0, cooldown =  10.0, shortcut = "0x7000B699" },
		["Call of Orom"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000B69A" },
		["Call of the Second Age"]					= { induction = 0.0, cooldown =  30.0, shortcut = "0x7000B69B" },
		["Call to Fate"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x7000F250" },

		["Raise the Spirit"]						= { induction = 1.0, cooldown =   1.5, shortcut = "0x70003E7B", alias = { "Raise My Spirit" } },
		["Inspire Fellows"]							= { induction = 2.5, cooldown =   5.0, shortcut = "0x70003E81" },
		["Bolster Courage"]							= { induction = 2.5, cooldown =   0.0, shortcut = "0x70003E85", alias = { "Bolster My Courage" } },
		["Enlivening Grace"]						= { induction = 8.0, cooldown =   0.0, shortcut = "0x70029904" },
		["Triumphant Spirit"]						= { induction = 0.0, cooldown = 600.0, shortcut = "0x70003E8C" },
		["Chord of Salvation"]						= { induction = 0.0, cooldown =  15.0, shortcut = "0x70029888", alias = { "Chord of My Salvation" } },
		["Rally!"]									= { induction = 5.0, cooldown =1200.0, shortcut = "0x70001251" },
		["Fellowship's Heart"]						= { induction = 2.0, cooldown = 600.0, shortcut = "0x70006CEB" },
		["Soliloquy of Spirit"]						= { induction = 0.0, cooldown =  30.0, shortcut = "0x7000F1F4", alias = { "Soliloquy of My Spirit" } },

		["Song of the Dead"]						= { induction = 3.0, cooldown =  60.0, shortcut = "0x70003E87" },
		["Song of Soothing"]						= { induction = 3.0, cooldown =  30.0, shortcut = "0x700031B7" },
		["Song of Aid"]								= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000318E" },
		["Song of Distraction"]						= { induction = 2.0, cooldown = 180.0, shortcut = "0x70029905" },
		["Symphony of the Hopeful Heart"]			= { induction = 5.0, cooldown = 300.0, shortcut = "0x7000125F" },
		["Song of Restoration"]						= { induction =15.0, cooldown = 600.0, shortcut = "0x7000F25F" },

		["Noble Cause"]								= { induction = 0.0, cooldown = 120.0, shortcut = "0x70003E84" },
		["Tale of Heroism"]							= { induction = 5.0, cooldown =   0.0, shortcut = "0x70003E89" },
		["Story of Courage"]						= { induction = 3.0, cooldown =  45.0, shortcut = "0x70029906" },
		["Tale of Battle"]							= { induction = 5.0, cooldown =   0.0, shortcut = "0x7000B661" },
		["Still as Death"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x70003E90" },
		["Tale of Warding"]							= { induction = 5.0, cooldown =   0.0, shortcut = "0x7000B660" },
		["Gift of the Hammerhand"]					= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000B69E" },
		["Herald's Strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = "0x70015A3D" },
		["Tale of Frost and Flame"]					= { induction = 5.0, cooldown =   0.0, shortcut = "0x7000F216" },
		["Tale of Frost and Flame's Battle"]		= { induction = 5.0, cooldown =   0.0, shortcut = "0x7000F21C" },
		["Tale of Warding and Heroism"]				= { induction = 5.0, cooldown =   0.0, shortcut = "0x7000F21B" },
		["Song of the Hammerhand"]					= { induction = 0.0, cooldown =  60.0, shortcut = "0x70020DF9" },
		["Coda of Vigour"]							= { induction = 0.0, cooldown =   1.0, shortcut = "0x700293C4", alias = { "Coda of Resonance", "Coda of Fury" } },
		["Harmony"]									= { induction = 5.0, cooldown =  10.0, shortcut = "0x700293C8" },

		["Piercing Cry"]							= { induction = 0.0, cooldown =  30.0, shortcut = "0x70003E7D" },
		["Invocation of Elbereth"]					= { induction = 0.0, cooldown =  30.0, shortcut = "0x70003E82" },
		["Cry of the Valar"]						= { induction = 0.0, cooldown =  60.0, shortcut = "0x70029A04" },
		["Call to the Fellowship"]					= { induction = 0.0, cooldown = 180.0, shortcut = "0x7000B69D" },
		["Call to Greatness"]						= { induction = 0.0, cooldown = 600.0, shortcut = "0x7000B69C" },
		["Cry of the Wizards"]						= { induction = 0.0, cooldown =  60.0, shortcut = "0x70001270" }
	},
	
	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Chilling Rhetoric"]						= { induction = 0.5, cooldown =  30.0, shortcut = "0x7000EE02" },
		["Essence of Winter"]						= { induction = 1.5, cooldown =  20.0, shortcut = "0x7000EE01" },
		["Flurry of Words"]							= { induction = 2.0, cooldown =  60.0, shortcut = "0x7000EDFF" },
		["Frozen Epilogue"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x7000EE03" },
		["Writ of Cold"]							= { induction = 0.8, cooldown =   5.0, shortcut = "0x7000EE00" },

		["Ceaseless Argument"]						= { induction = 0.0, cooldown =   0.0, shortcut = "0x7000EEAC" },
		["Epic Conclusion"]							= { induction = 0.0, cooldown =  90.0, shortcut = "0x7000EEAF" },
		["Essence of Storm"]						= { induction = 0.0, cooldown =   8.0, shortcut = "0x7000EEAB" },
		["Scribe's Spark"]							= { induction = 0.0, cooldown =   3.0, shortcut = "0x7000EEAD" },
		["Shocking Words"]							= { induction = 0.0, cooldown =  25.0, shortcut = "0x7000EEAE" },
		["Sustaining Bolt"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x70029CFC" },
		["Vivid Imagery"]							= { induction = 0.0, cooldown = 300.0, shortcut = "0x700180F9" },

		["Armour of Storm"]							= { induction = 0.0, cooldown = 180.0, shortcut = "0x7000F33A", alias = { "Armour of Flame", "Armour of Winter" }  },
		["Calming Verse"]							= { induction = 0.0, cooldown =  60.0, shortcut = "0x7000E996" },
		["Distracting Winds"]						= { induction = 0.0, cooldown = 180.0, shortcut = "0x7000EC5D" },
		["Final Word"]								= { induction = 0.0, cooldown =  30.0, shortcut = "0x70018775" },
		["Master of Writs"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x70024D37" },
		["Nothing Truly Ends"]						= { induction = 5.0, cooldown =   0.0, shortcut = "0x7000EDA1" },
		["Self Motivation"]							= { induction = 0.0, cooldown = 120.0, shortcut = "0x7000E037", power = 0.00 },
		["Shocking Touch"]							= { induction = 0.0, cooldown =  20.0, shortcut = "0x7000F488" },
		["Steady Hands"]							= { induction = 1.5, cooldown = 300.0, shortcut = "0x700180F2" },
		["Weapon of Storm"]							= { induction = 0.0, cooldown =   5.0, shortcut = "0x70020DFC", alias = { "Weapon of Flame", "Weapon of Winter" }  },

		["Do Not Fall to Storm"]					= { induction = 1.5, cooldown =  30.0, shortcut = "0x7000F343", alias = { "Do Not Fall to Flame", "Do Not Fall to Winter" } },
		["Do Not Fall This Day"]					= { induction = 0.0, cooldown = 900.0, shortcut = "0x7001F4A0" },
		["Fall to our Wrath"]						= { induction = 0.0, cooldown =  30.0, shortcut = "0x700180F3" },
		["Fall to Storm"]							= { induction = 0.0, cooldown =  30.0, shortcut = "0x7000F340", alias = { "Fall to Flame", "Fall to Winter" } },
		["The Blade will not Wound"]				= { induction = 1.5, cooldown =  60.0, shortcut = "0x7000F2A1" },
		["The Fang will not Poison"]				= { induction = 1.5, cooldown =  60.0, shortcut = "0x7000F2A0" },

		["Epic for the Ages"]						= { induction = 4.5, cooldown =   3.0, shortcut = "0x7000EEA6" },
		["Essay of Exaltation"]						= { induction = 0.0, cooldown = 300.0, shortcut = "0x70018636" },
		["Glorious Foreshadowing"]					= { induction = 1.5, cooldown = 180.0, shortcut = "0x700180F7", alias = { "Wondrous Foreshadowing" } },
		["Mending Verse"]							= { induction = 2.0, cooldown =   0.0, shortcut = "0x7000EEA8" },
		["Our Fates Entwined"]						= { induction = 0.0, cooldown =   5.0, shortcut = "0x70018776" },
		["Prelude to Hope"]							= { induction = 0.0, cooldown =   3.0, shortcut = "0x70029CFB" },
		["Rousing Words"]							= { induction = 0.0, cooldown =  20.0, shortcut = "0x70029CFA" },
		["Rune of Restoration"]						= { induction = 1.5, cooldown =  15.0, shortcut = "0x7000EEA5" },
		["That Which Does Not Kill Us"]				= { induction = 1.5, cooldown = 600.0, shortcut = "0x700180F4" },
		["Word of Exaltation"]						= { induction = 0.0, cooldown =  90.0, shortcut = "0x7000EEA7" },
		["Writ of Health"]							= { induction = 0.8, cooldown =   5.0, shortcut = "0x7000EEA9" },

		["Distracting Flame"]						= { induction = 1.0, cooldown =  60.0, shortcut = "0x700180F5", alias = { "Mystifying Flame" } },
		["Essay of Fire"]							= { induction = 6.0, cooldown =  60.0, shortcut = "0x70029CF7" },
		["Essence of Flame"]						= { induction = 3.0, cooldown =  15.0, shortcut = "0x7000EFEF" },
		["Fiery Ridicule"]							= { induction = 1.5, cooldown =   0.0, shortcut = "0x7000E96B" },
		["Scathing Mockery"]						= { induction = 3.0, cooldown =  20.0, shortcut = "0x70029CF9" },
		["Smoldering Wrath"]						= { induction = 0.0, cooldown =  60.0, shortcut = "0x7000E96D" },
		["Writ of Fire"]							= { induction = 0.8, cooldown =   5.0, shortcut = "0x7000EFF0" }
	},

	[Turbine.Gameplay.Class.Warden] = {
		["Quick Thrust"]							= { induction = 0.0, cooldown =   1.0, shortcut = "0x7000E867" },
		["Shield-bash"]								= { induction = 0.0, cooldown =   1.0, shortcut = "0x7000ED0E" },
		["Warden's Taunt"]							= { induction = 0.0, cooldown =   1.0, shortcut = "0x7000EECF" },
		["Quick Recovery"]							= { induction = 0.0, cooldown =   3.0, shortcut = "0x70016A09" },
		["Recovery"]								= { induction = 0.0, cooldown =   3.0, shortcut = "0x70016A0A" },
		["Spear and Shield"]						= { induction = 0.0, cooldown =  15.0, shortcut = "0x70015099" },
		["Spear and Fist"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x70015098" },
		["Shield and Spear"]						= { induction = 0.0, cooldown =  15.0, shortcut = "0x7001509D" },
		["Shield and Fist"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x7001509B" },
		["Fist and Spear"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x7001509A" },
		["Fist and Shield"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x7001509C" },
		["Spear and Spear"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x7002850A" },
		["Shield and Shield"]						= { induction = 0.0, cooldown =  15.0, shortcut = "0x7002850B" },
		["Fist and Fist"]							= { induction = 0.0, cooldown =  15.0, shortcut = "0x7002850C" },

		["Ambush"]									= { induction = 5.0, cooldown =  30.0, shortcut = "0x7000EEC4" },
		["Hampering Javelin"]						= { induction = 0.0, cooldown =  45.0, shortcut = "0x70014833" },
		["Javelin of Deadly Force"]					= { induction = 0.0, cooldown =  45.0, shortcut = "0x700156A0" },
		["Javelin-toss"]							= { induction = 0.0, cooldown =   8.0, shortcut = "0x70028390" },
		["Shield Piercer"]							= { induction = 0.0, cooldown =  45.0, shortcut = "0x70014784" },
		["Wages of Fear"]							= { induction = 0.0, cooldown =  45.0, shortcut = "0x70014831" },

		["Determination"]							= { induction = 0.0, cooldown =   4.2, shortcut = "0x7000ECD7" },
		["Conservation"]							= { induction = 0.0, cooldown =   4.0, shortcut = "0x70014799" },
		["Recklessness"]							= { induction = 0.0, cooldown =   4.0, shortcut = "0x70014832" },
		["Way of the Warden"]						= { induction = 0.0, cooldown = 900.0, shortcut = "0x700156A2" },

		["Careful Step"]							= { induction = 5.0, cooldown = 180.0, shortcut = "0x70014860" },
		["Critical Strike"]							= { induction = 0.0, cooldown =  30.0, shortcut = "0x700101D8" },
		["Forced March"]							= { induction = 0.0, cooldown =   1.5, shortcut = "0x700105CC", power = 0.50 },
		["Never Surrender"]							= { induction = 0.0, cooldown = 900.0, shortcut = "0x700244BD" }
	}
}

raceSkillTable = {
	[Turbine.Gameplay.Race.Dwarf] = {
		["Dwarf Endurance"]							= { induction = 0.0, cooldown =3600.0, shortcut = "0x7000634E", power = 0.20 },
		["Endurance of Stone"]						= { induction = 0.0, cooldown =3600.0, shortcut = "0x7000634A", power = 0.20 }
	},

	[Turbine.Gameplay.Race.Elf] = {
		["Eldar's Grace"]							= { induction = 0.0, cooldown =3600.0, shortcut = "0x70006323", power = 0.00 },
		["Power of the Eldar"]						= { induction = 0.0, cooldown =3600.0, shortcut = "0x70006329", power = 0.20 },
		["Silvan Shadows"]							= { induction = 0.0, cooldown =1800.0, shortcut = "0x70006317", power = 0.20 }
	},

	[Turbine.Gameplay.Race.Hobbit] = {
		["Hobbit Resilence"]						= { induction = 0.0, cooldown =3600.0, shortcut = "0x700062CE", power = 0.20 },
		["Hobbit Silence"]							= { induction = 0.0, cooldown =3600.0, shortcut = "0x700062D7", power = 0.20 },
		["Hobbit Stealth"]							= { induction = 0.0, cooldown =3600.0, shortcut = "0x700062D3", power = 0.20 }
	},

	[Turbine.Gameplay.Race.Man] = {
		["Duty-bound"]								= { induction = 0.0, cooldown =3600.0, shortcut = "0x700062FA", power = 0.20 },
		["Strength of Morale"]						= { induction = 0.0, cooldown =3600.0, shortcut = "0x70006301", power = 0.20 }
	}
};
			  
keymap = { };

for k, v in pairs(quickKeys) do
	keymap[v] = k;
end

SkillInfoQuickslot = class(Turbine.UI.Lotro.Quickslot);

function SkillInfoQuickslot:Constructor(parent, size, index)
	Turbine.UI.Lotro.Quickslot.Constructor(self);

	self:SetParent(parent);
	self:SetSize(size, size);
	self:SetUseOnRightClick(false);

	self.state = 0;
	self.index = index;
	self.safe = false;

	self.MouseEnter = moebius92.NormalQuickslot.MouseEnter;
	self.MouseLeave = moebius92.NormalQuickslot.MouseLeave;
	self.MouseUp = moebius92.NormalQuickslot.MouseUp;
	self.DragLeave = moebius92.NormalQuickslot.DragLeave;
	self.ShortcutChanged = SIQShortcutChanged;
	self.MouseClick = SIQMouseClick;
end

function SIQMouseClick(sender, args)
	local parent = sender:GetParent();
	local skill = parent.quickskills[sender.index]

	if skill ~= nil then
		Turbine.Shell.WriteLine(skill);
		if curSkillTable[skill] ~= nil then
			local t = { };
			local s = "";

			for k in pairs(curSkillTable[skill].powers) do
				table.insert(t, k);
			end
			table.sort(t);
			for i = 1, #t do
				if i == 1 then
					s = t[i];
				else
					s = s .. ", " .. t[i];
				end
			end

			Turbine.Shell.WriteLine("Shortcut: " .. curSkillTable[skill].shortcut);
			Turbine.Shell.WriteLine("Induction: " .. curSkillTable[skill].inductionmin .. "s - " .. curSkillTable[skill].inductionmax .. "s");
			Turbine.Shell.WriteLine("Power Cost: " .. s);
			Turbine.Shell.WriteLine("Cooldown: <= " .. curSkillTable[skill].cooldownmax .. "s");
		end
	end
end

function SIQShortcutChanged(sender, args)
	local shortcut = sender:GetShortcut();
	local parent = sender:GetParent();

	if not sender.safe then
		for k, v in pairs(parent.qsHandlers) do
			v("!keymap", time, nil);
		end

		if shortcut == nil or shortcut:GetType() == Turbine.UI.Lotro.ShortcutType.Undefined then
			parent.settings.quickslots[sender.index] = nil;
		else
			local found = false;

			if shortcut:GetType() == Turbine.UI.Lotro.ShortcutType.Skill then
				local data = shortcut:GetData();

				if classSkillTable[parent.class] ~= nil then
					for k, v in pairs(classSkillTable[parent.class]) do
						if v.shortcut == data then
							found = true;
							parent.settings.quickslots[sender.index] = data;
							break;
						end
					end
				end

				if not found and raceSkillTable[parent.race] ~= nil then
					for k, v in pairs(raceSkillTable[parent.race]) do
						if v.shortcut == data then
							found = true;
							parent.settings.quickslots[sender.index] = data;
							break;
						end
					end
				end

				if not found then
					Turbine.Shell.WriteLine("Shortcut '" .. shortcut:GetData() .. "' not found.");
				end
			end

			if not found then
				sender:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Undefined, ""));
			end
		end
	end

	parent:SaveSettings();
	parent:SetVisible(false);
	parent:SetVisible(true);
end

SkillInfoWindow = class(Turbine.UI.Window);

function SkillInfoWindow:Constructor()
	Turbine.UI.Window.Constructor(self);

	self.settings = SkillInfoWindowLoadCharacterSettings();
	self.timings = SkillInfoWindowLoadAccountSettings();
	self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	self.class = self.player:GetClass();
	self.race = self.player:GetRace();
	self.power = self.player:GetPower();
	self.name = self.player:GetName();
	generateCurSkillTable(self.settings.trait, self.settings.legacy, self.settings.equip, self.settings.set, self.class, self.race, self.settings.power)

	self.visible = false;
	self.hide = false;
	self.handle = 0;
	self.qsHandlers = { };

	self.stopwatch = -1;
	self.stopwatchCount = 0;
	self.stopwatchTotal = 0;

	self.calibrateCount = 0;
	self.calibrateTotal = 0;
	self.calibrateMin = 0;

	self.effects = self.player:GetEffects();
	moebius92.Handlers.AddEventHandler(self.effects, "EffectAdded",
function(sender, args)
	if self.effects:Get(args.Index):GetName() == "Mischievous Glee" then
		self:ChatMessage(self.name .. " applied a benefit with Mischievous Glee on " .. self.name, self.effects:Get(args.Index):GetStartTime());
	end
end
	               );

	moebius92.Handlers.AddEventHandler(self.player, "LevelChanged", function(sender, args) self.settings.power = { }; end);
	moebius92.Handlers.AddEventHandler(self.player, "PowerChanged", function(sender, args) self:UpdatePower(); end);
	moebius92.Handlers.AddEventHandler(self.player, "MaxPowerChanged", function(sender, args) self:UpdateMaxPower(); end);
	moebius92.Handlers.AddChatHandler(function(m) self:ChatMessage(m, Turbine.Engine.GetGameTime()) end, Turbine.ChatType.Combat, self.name);
	self:SetWantsKeyEvents(true);
	self:UpdateMaxPower();

	self.width = 36;
	local x = (Turbine.UI.Display.GetWidth() - self.width * 12) / 2;
	self:SetPosition(x, 0);
	self:SetSize(self.width * 12, self.width * 6);
	self:SetMouseVisible(false);

	self.quickslots = { };
	for i = 1, 72 do
		self.quickslots[i] = SkillInfoQuickslot(self, self.width, i);
		self.quickslots[i]:SetPosition(((i - 1) % 12) * self.width, (5 - math.floor((i - 1) / 12)) * self.width);
		self.quickslots[i].safe = true;
		if self.settings.quickslots[i] ~= nil then
			self.quickslots[i]:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Skill, self.settings.quickslots[i]));
		end
		self.quickslots[i].safe = false;
	end
	self:SetVisible(false);
	self:SaveSettings();
end

function SkillInfoWindow:SetVisible(v)
	if v ~= nil then
		self.visible = v;
	end
	Turbine.UI.Window.SetVisible(self, self.visible and not self.hide);
end

function SkillInfoWindow:AddQuickslotHandler(f)
	local h = self.handle;

	self.qsHandlers[h] = f;
	self.handle = h + 1;
	return h;
end

function SkillInfoWindow:RemoveQuickslotHandler(h)
	self.qsHandlers[h] = nil;
end

function SkillInfoWindow:ReportQuickslot(k)
	for _, v in pairs(self.settings.quickslots) do
		if classSkillTable[self.class] ~= nil then
			for k1, v1 in pairs(classSkillTable[self.class]) do
				if v1.shortcut == v and k1 == k then
					return true;
				end
			end
		end

		if raceSkillTable[self.race] ~= nil then
			for k1, v1 in pairs(raceSkillTable[self.race]) do
				if v1.shortcut == v and k1 == k then
					return true;
				end
			end
		end
	end

	return false;
end

function SkillInfoWindow:ChatMessage(m, time)
	local i;
	local name, rest;
	local skill, type;

	m = string.gsub(m, "<[^>]*>", "");
	i = string.find(m, " ");

	if i ~= nil then
		name = trim(string.sub(m, 1, i - 1));
		rest = trim(string.sub(m, i + 1, -1));
		if name == self.name then
			if string.sub(rest, 1, 23) == "applied a benefit with " then
				type = "B";
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, 24, i - 1);
				end
			elseif string.sub(rest, 1, 9) == "scored a " then
				type = "H";
				local j = string.find(rest, " with ");
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, j + 6, i - 1);
				end
			elseif string.sub(rest, 1, 21) == "missed trying to use " then
				type = "M";
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, 2, i - 1);
				end
			elseif string.sub(rest, 1, 13) == "tried to use " then
				type = "R";
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, 14, i - 1);
				end
			end
		end
	end

	if type == nil then
		return;
	end

	if string.sub(skill, 1, 9) == "Improved " then
		skill = string.sub(skill, 10);
	end
	if string.sub(skill, 1, 9) == "Advanced " then
		skill = string.sub(skill, 10);
	end
	i = string.find(skill, " %(");
	if i ~= nil then
		skill = string.sub(skill, 1, i - 1);
	end
	if curSkillAlias[skill] ~= nil then
		skill = curSkillAlias[skill];
	end

	if curSkillTable[skill] ~= nil then
		local kptr = self.keys;
		local prev = nil;

		while kptr ~= nil and kptr.skill ~= skill do
			prev = kptr;
			kptr = kptr.next;
		end

		if kptr ~= nil then
			if prev == nil then
				self.keys = nil;
			else
				prev.next = nil;
			end

			if self.powers ~= nil and self.powers.time > kptr.time and (self.powers.next == nil or self.powers.next.time < kptr.time) then
				if self.powers.key ~= nil then
					self.powers.key.claimed = nil;
				end

				if self.powers.key == nil or self.powers.key.skill ~= skill then
					for k, v in pairs(self.qsHandlers) do
						v(skill, self.powers.time, "P");
					end
				end

				if curSkillTable[skill].power == nil then
					if self.settings.power[skill] == nil then
						self.settings.power[skill] = { };
					end

					local power = self.powers.power;
					local item = self.settings.power[skill][power];

					if item == nil then
						item = { };
						item.count = 0;
						self.settings.power[skill][power] = item;
						curSkillTable[skill].powers[power] = 1;
					end
					item.count = item.count + 1;
					item.usage = item.count * usageMultiplier;

					for k, v in pairs(self.settings.power[skill]) do
						v.usage = v.usage - 1;
						if v.usage < 0 then
							self.settings.power[skill][k] = nil;
							curSkillTable[skill].powers[k] = nil;
						end
					end

					self:SaveSettings();
				end

				self.powers = nil;
			end
		end

		for k, v in pairs(self.qsHandlers) do
			v(skill, time, type);
		end
	end
end

function SkillInfoWindow:UpdateMaxPower()
	local maxPower = self.player:GetMaxPower();

	for _, v in pairs(curSkillTable) do
		if v.power ~= nil and v.power > 0 then
			local cost = math.floor(maxPower * v.power + 0.5);

			v.powers = { };
			if v.powermod ~= nil then
				for _, m in pairs(v.powermod) do
					t = math.floor((cost + m.abs) * (m.per / 100) + 0.5);
					v.powers[t] = 1;
				end
			else
				v.powers[cost] = 1;
			end
		end
	end
end

function SkillInfoWindow:UpdatePower()
	local power = self.player:GetPower();
	local delta = self.power - power;
	local time = Turbine.Engine.GetGameTime();

	if delta > 0 and math.floor(delta) == delta then
		local prev = nil;
		local ptr = self.powers;

		while ptr ~= nil and (ptr.time + 10) > time do
			prev = ptr;
			ptr = ptr.next;
		end

		if ptr ~= nil then
			if prev == nil then
				self.powers = nil;
			else
				prev.next = nil;
			end
		end

		local item = { };

		item.next = self.powers;
		item.time = time;
		item.power = delta;
		self.powers = item;

		if self.calibrate ~= nil then
			if self.calibrateCount == 0 or self.calibrateMin > (time - self.calibrate) then
				self.calibrateMin = time - self.calibrate;
			end
			self.calibrateCount = self.calibrateCount + 1;
			self.calibrateTotal = self.calibrateTotal + (time - self.calibrate);
			Turbine.Shell.WriteLine("Mean: " .. (self.calibrateTotal / self.calibrateCount));
			Turbine.Shell.WriteLine("Minimum: " .. self.calibrateMin);
			self.calibrate = nil;
		end

		local score, dtime;
		local bptr = nil;
		local bscore = nil;

		ptr = self.keys;
		prev = nil;

		while ptr ~= nil and ptr.claimed == nil do
			if curSkillTable[ptr.skill] ~= nil then
				if curSkillTable[ptr.skill].powers[delta] ~= nil then
					score = time - ptr.time;
					if score > (curSkillTable[ptr.skill].inductionmax + meanTime) then
						score = score - curSkillTable[ptr.skill].inductionmax;
					elseif score < (curSkillTable[ptr.skill].inductionmin + meanTime) then
						score = score - curSkillTable[ptr.skill].inductionmin;
					else
						score = meanTime;
					end

					if score > minTime then
						score = math.abs(score - meanTime);
						if bscore == nil or score < bscore then
							bscore = score;
							bptr = ptr;
						end
					end
				end
			end

			ptr = ptr.next;
		end

		if bptr ~= nil then
			for k, v in pairs(self.qsHandlers) do
				v(bptr.skill, time, "P");
			end

			item.key = bptr;
			bptr.claimed = true;
		end

		if self.stopwatch == 0 then
			self.stopwatch = time;
		elseif self.stopwatch > 0 then
			delta = time - self.stopwatch;
			self.stopwatch = time;
			self.stopwatchCount = self.stopwatchCount + 1;
			self.stopwatchTotal = self.stopwatchTotal + delta;
			Turbine.Shell.WriteLine(delta);
		end
	end

	self.power = power;
end

function SkillInfoWindow:QuickslotClicked(shortcut, time)
	if curSkillTable ~= nil then
		if self.calibrate then
			self.calibrate = time;
		end

		for k, v in pairs(curSkillTable) do
			if v.shortcut == shortcut then
				local prev = nil;
				local ptr = self.keys;

				while ptr ~= nil and (ptr.time + 10) > time do
					prev = ptr;
					ptr = ptr.next;
				end

				if ptr ~= nil then
					if prev == nil then
						self.keys = nil;
					else
						prev.next = nil;
					end
				end

				local item = { };

				item.next = self.keys;
				item.time = time;
				item.skill = k;
				self.keys = item;
				return;
			end
		end
	end
end

function SkillInfoWindow:KeyDown(args)
	local time = Turbine.Engine.GetGameTime();

	if keymap[args.Action] ~= nil then
		k = keymap[args.Action];

		if self.calibrate then
			self.calibrate = time;
		end

		if self.quickskills[k] ~= nil then
			local prev = nil;
			local ptr = self.keys;

			while ptr ~= nil and (ptr.time + 10) > time do
				prev = ptr;
				ptr = ptr.next;
			end

			if ptr ~= nil then
				if prev == nil then
					self.keys = nil;
				else
					prev.next = nil;
				end
			end

			local item = { };

			item.next = self.keys;
			item.time = time;
			item.skill = self.quickskills[k];
			self.keys = item;
		end
	elseif args.Action == 0x100000B3 then
		self.hide = not self.hide;
		self:SetVisible();
	end
end

function removeEntries(t, entries)
	if entries ~= nil then
		for _, v in pairs(entries) do
			t[v] = nil;
		end
	end
end

function updateMod(mod, amt, maxper)
	local l = string.len(amt);

	if string.sub(amt, l) == "%" then
		for _, v in pairs(mod) do
			if maxper then
				v.per = math.min(v.per, 100 + string.sub(amt, 1, l - 1));
			else
				v.per = v.per + string.sub(amt, 1, l - 1);
			end
		end
	else
		for _, v in pairs(mod) do
			v.abs = v.abs + string.sub(amt, 1, l - 1);
		end
	end
end

function updateModBuff(mod, amt, amtmod)
	if amtmod == nil then
		updateMod(mod, amt, false);
		return;
	end

	local l = string.len(amt);

	if string.sub(amt, l) == "%" then
		for _, v in pairs(mod) do
			v.per = v.per + string.sub(amt, 1, l - 1);
		end

		local t = tableCopy(mod);
		for _, v in pairs(mod) do
			v.per = v.per + amtmod[1].per
		end
		for i = 2, #amtmod do
			local new = tableCopy(t);
			for _, v in pairs(new) do
				v.per = v.per + amtmod[i].per
			end
			unionAssignMod(mod, t);
		end
	else
		for _, v in pairs(mod) do
			v.abs = v.abs + string.sub(amt, 1, l - 1);
		end

		local t = tableCopy(mod);
		for _, v in pairs(mod) do
			v.abs = v.abs + amtmod[1].abs
		end
		for i = 2, #amtmod do
			local new = tableCopy(t);
			for _, v in pairs(new) do
				v.abs = v.abs + amtmod[i].abs
			end
			unionAssignMod(mod, t);
		end
	end
end

function updateTable(tbl, update, maxper)
	if update ~= nil then
		if update.skills ~= nil then
			for _, v in pairs(update.skills) do
				if tbl[v] ~= nil then
					if update.induction ~= nil then
						updateMod(tbl[v].inductionmod, update.induction, maxper);
					end
					if update.power ~= nil then
						updateMod(tbl[v].powermod, update.power, false);
					end
					if update.cooldown ~= nil then
						updateMod(tbl[v].cooldownmod, update.cooldown, false);
					end
				end
			end
		else
			if update.induction ~= nil then
				for k, v in pairs(update.induction) do
					if tbl[k] ~= nil then
						updateMod(tbl[k].inductionmod, v, false);
					end
				end
			end
			if update.power ~= nil then
				for k, v in pairs(update.power) do
					if tbl[k] ~= nil then
						updateMod(tbl[k].powermod, v, false);
					end
				end
			end
			if update.cooldown ~= nil then
				for k, v in pairs(update.cooldown) do
					if tbl[k] ~= nil then
						updateMod(tbl[k].cooldownmod, v, false);
					end
				end
			end
		end
	end
end

function tableCopy(t)
	local r = { };
	for k, v in pairs(t) do
		if type(v) == "table" then
			r[k] = tableCopy(v);
		else
			r[k] = v;
		end
	end
	return r;
end

function updateTableTiers(tbl, update, tier)
	if update[tier] ~= nil then
		if update.skills ~= nil then
			for _, v in pairs(update.skills) do
				if tbl[v] ~= nil then
					local t = getTier(tbl[v], tier - 1);

					if tbl[v].tiering == nil then
						tbl[v].tiering = { };
					end

					tbl[v].tiering[tier] = { };

					if update[tier].induction ~= nil then
						tbl[v].tiering[tier].inductionmod = tableCopy(t.inductionmod);
						updateModBuff(tbl[v].tiering[tier].inductionmod, update[tier].induction, update.inductionmod);
					end
					if update[tier].power ~= nil then
						tbl[v].tiering[tier].powermod = tableCopy(t.powermod);
						updateModBuff(tbl[v].tiering[tier].powermod, update[tier].power, update.powermod);
					end
					if update[tier].cooldown ~= nil then
						tbl[v].tiering[tier].cooldownmod = tableCopy(t.cooldownmod);
						updateModBuff(tbl[v].tiering[tier].cooldownmod, update[tier].cooldown, update.cooldownmod);
					end
				end
			end
		else
			if update[tier].induction ~= nil then
				for k, v in pairs(update[tier].induction) do
					if tbl[k] ~= nil then
						local t = getTier(tbl[k], tier);

						if tbl[k].tiering == nil then
							tbl[k].tiering = { };
						end
						if tbl[k].tiering[tier] == nil then
							tbl[k].tiering[tier] = { };
						end

						tbl[k].tiering[tier].inductionmod = tableCopy(t.inductionmod);
						updateModBuff(tbl[k].tiering[tier].inductionmod, v, update.inductionmod);
					end
				end
			end
			if update[tier].power ~= nil then
				for k, v in pairs(update[tier].power) do
					if tbl[k] ~= nil then
						local t = getTier(tbl[k], tier);

						if tbl[k].tiering == nil then
							tbl[k].tiering = { };
						end
						if tbl[k].tiering[tier] == nil then
							tbl[k].tiering[tier] = { };
						end

						tbl[k].tiering[tier].powermod = tableCopy(t.powermod);
						updateModBuff(tbl[k].tiering[tier].powermod, v, update.powermod);
					end
				end
			end
			if update[tier].cooldown ~= nil then
				for k, v in pairs(update[tier].cooldown) do
					if tbl[k] ~= nil then
						local t = getTier(tbl[k], tier);

						if tbl[k].tiering == nil then
							tbl[k].tiering = { };
						end
						if tbl[k].tiering[tier] == nil then
							tbl[k].tiering[tier] = { };
						end

						tbl[k].tiering[tier].cooldownmod = tableCopy(t.cooldownmod);
						updateModBuff(tbl[k].tiering[tier].cooldownmod, v, update.cooldownmod);
					end
				end
			end
		end
	end	
end

function unionAssignMod(a, b)
	for _, v1 in pairs(b) do
		local found = false;

		for _, v2 in pairs(a) do
			if v1.abs == v2.abs and v1.per == v2.per then
				found = true;
				break;
			end
		end

		if not found then
			table.insert(a, v1);
		end
	end
end

function getTier(skill, tier)
	local inductionmod, powermod, cooldownmod;

	if skill.tiering ~= nil then
		while tier > 0 do
			if skill.tiering[tier] ~= nil then
				if inductionmod == nil then
					inductionmod = skill.tiering[tier].inductionmod;
				end
				if powermod == nil then
					powermod = skill.tiering[tier].powermod;
				end
				if cooldownmod == nil then
					cooldownmod = skill.tiering[tier].cooldownmod;
				end
			end
			tier = tier - 1;
		end
	end

	if inductionmod == nil then
		inductionmod = skill.inductionmod;
	end
	if powermod == nil then
		powermod = skill.powermod;
	end
	if cooldownmod == nil then
		cooldownmod = skill.cooldownmod;
	end

	return { inductionmod = inductionmod, powermod = powermod, cooldownmod = cooldownmod };
end

function updateTableCleanTiers(tbl, tiers)
	for k, v in pairs(tbl) do
		if v.tiering ~= nil then
			if tiers == nil then
				for _, t in pairs(v.tiering) do
					if t.inductionmod ~= nil then
						unionAssignMod(v.inductionmod, t.inductionmod);
					end
					if t.powermod ~= nil then
						unionAssignMod(v.powermod, t.powermod);
					end
					if t.cooldownmod ~= nil then
						unionAssignMod(v.cooldownmod, t.cooldownmod);
					end
				end
			else
				local inductionmod = nil;
				local powermod = nil;
				local cooldownmod = nil;

				for _, i in pairs(tiers) do
					local tier = getTier(v, i);

					if inductionmod == nil then
						inductionmod = tier.inductionmod;
						powermod = tier.powermod;
						cooldownmod = tier.cooldownmod;
					else
						unionAssignMod(inductionmod, tier.inductionmod);
						unionAssignMod(powermod, tier.powermod);
						unionAssignMod(cooldownmod, tier.cooldownmod);
					end
				end

				v.inductionmod = inductionmod;
				v.powermod = powermod;
				v.cooldownmod = cooldownmod;
			end
			v.tiering = nil;
		end
	end
end

function updateTableEquip(tbl, update, values)
	for _, v in pairs(update.skills) do
		if tbl[v] ~= nil then
			local mod = nil;
			local cur = nil;

			for _, m in pairs(values) do
				cur = tableCopy(tbl[v][update.type]);
				updateMod(cur, m, false);

				if mod == nil then
					mod = cur;
				else
					unionAssignMod(mod, cur);
				end
			end

			if mod ~= nil then
				tbl[v][update.type] = mod;
			end
		end
	end
end

function generateCurSkillTable(trait, legacy, equip, set, class, race, power)
	local curBuffTable = { };
	local traitSet = { };
	local classTrait = traitTable[class];

	curSkillTable = { };
	curSkillAlias = { };

	if classSkillTable[class] == nil then
		return;
	end

	for k in pairs(trait) do
		if classTrait[k] ~= nil then
			local s = classTrait[k].set;
			if s ~= "Set" and s ~= "Legendary" then
				if traitSet[s] == nil then
					traitSet[s] = 0;
				end
				traitSet[s] = traitSet[s] + 1;
			end
		end
	end

	for k, v in pairs(classSkillTable[class]) do
		curSkillTable[k] = v;
	end

	for k, v in pairs(buffTable[class]) do
		curBuffTable[k] = v;
	end

	for k, v in pairs(classTrait) do
		if v.set == "Set" then
			for i = 2, 7 do
				if v[i] ~= nil then
					if traitSet[k] ~= nil and i <= traitSet[k] then
						removeEntries(curSkillTable, v[i].disable);
						removeEntries(curBuffTable, v[i].disable);
					else
						removeEntries(curSkillTable, v[i].enable);
						removeEntries(curBuffTable, v[i].enable);
					end
				end
			end
		else
			if trait[k] ~= nil then
				removeEntries(curSkillTable, v.disable);
				removeEntries(curBuffTable, v.disable);
			else
				removeEntries(curSkillTable, v.enable);
				removeEntries(curBuffTable, v.enable);
			end
		end
	end

	for k, v in pairs(curSkillTable) do
		v.inductionmod = { { abs = 0, per = 100 } };
		v.powermod = { { abs = 0, per = 100 } };
		v.cooldownmod = { { abs = 0, per = 100 } };
	end

	for k, v in pairs(curBuffTable) do
		v.inductionmod = { { abs = 0, per = 0.0 } };
		v.powermod = { { abs = 0, per = 0.0 } };
		v.cooldownmod = { { abs = 0, per = 0.0 } };
	end

	for k in pairs(trait) do
		if classTrait[k] ~= nil then
			updateTable(curSkillTable, classTrait[k], true);
			updateTable(curBuffTable, classTrait[k], false);
		end
	end

	for k, v in pairs(traitSet) do
		if classTrait[k] ~= nil then
			for i = 2, math.min(4, traitSet[k]) do
				updateTable(curSkillTable, classTrait[k][i], false);
				updateTable(curBuffTable, classTrait[k][i], false);
			end
		end
	end

	local classLegacy = legacyTable[class];
	for k, v in pairs(legacy) do
		if classLegacy[k] ~= nil then
			updateTableEquip(curSkillTable, classLegacy[k], v);
			updateTableEquip(curBuffTable, classLegacy[k], v);
		end
	end

	local classSet = setTable[class];
	for k, v in pairs(set) do
		if classSet[k] ~= nil then
			for i = 1, classSet[k].tiers do
				updateTableTiers(curSkillTable, classSet[k], i);
				updateTableTiers(curBuffTable, classSet[k], i);
			end
			updateTableCleanTiers(curSkillTable, v);
			updateTableCleanTiers(curBuffTable, v);
		end
	end

	local classEquip = equipTable[class];
	for k, v in pairs(equip) do
		if classEquip[k] ~= nil then
			updateTableEquip(curSkillTable, classEquip[k], v);
			updateTableEquip(curBuffTable, classEquip[k], v);
		end
	end

	for k, v in pairs(curBuffTable) do
		if v.tiers == nil then
			updateTableTiers(curSkillTable, curBuffTable[k], 1);
		else
			for i = 1, v.tiers do
				updateTableTiers(curSkillTable, curBuffTable[k], i);
			end
		end
		updateTableCleanTiers(curSkillTable, nil);
	end

	for k, v in pairs(curSkillTable) do
		local t;

		v.inductionmin = nil;
		v.inductionmax = nil;
		for _, m in pairs(v.inductionmod) do
			t = (v.induction + m.abs) * (m.per / 100);
			if v.inductionmin == nil or v.inductionmin > t then
				v.inductionmin = t;
			end
			if v.inductionmax == nil or v.inductionmax < t then
				v.inductionmax = t;
			end
		end
		v.inductionmod = nil;

		v.powers = { };
		if v.power == nil and power[k] then
			for k1, v1 in pairs(power[k]) do
				v.powers[k1] = 1;
			end
		end

		v.cooldownmax = nil;
		for _, m in pairs(v.cooldownmod) do
			t = math.max(0, (v.cooldown * (m.per / 100)) + m.abs);
			if v.cooldownmax == nil or v.cooldownmax < t then
				v.cooldownmax = t;
			end
		end
		v.cooldownmod = nil;

	end

	if raceSkillTable[race] == nil then
		for k, v in pairs(raceSkillTable[race]) do
			curSkillTable[k] = v;
		end
	end

	for k, v in pairs(curSkillTable) do
		if v.alias ~= nil then
			for _, a in pairs(v.alias) do
				curSkillAlias[a] = k;
			end
		end
	end
end

function SkillInfoWindow:findByShortcut(s)
	if curSkillTable ~= nil then
		for k, v in pairs(curSkillTable) do
			if v.shortcut == s then
				return k;
			end
		end
	end

	if classSkillTable[self.class] ~= nil then
		for k, v in pairs(classSkillTable[self.class]) do
			if v.shortcut == s then
				return k;
			end
		end
	end

	if raceSkillTable[self.race] ~= nil then
		for k, v in pairs(raceSkillTable[self.race]) do
			if v.shortcut == s then
				return k;
			end
		end
	end

	return nil;
end

function SkillInfoWindow:getShortcut(s)
	if curSkillTable[s] == nil then
		return nil;
	end

	return curSkillTable[s].shortcut;
end

function SkillInfoWindow:getSharedCooldown(s)
	if classSkillTable[self.class][s] ~= nil and classSkillTable[self.class][s].sharedCooldown ~= nil then
		return classSkillTable[self.class][s].sharedCooldown;
	end
	return { };
end

function SkillInfoWindow:getMaxCooldown(s)
	if curSkillTable[s] == nil then
		return 0;
	end

	return curSkillTable[s].cooldownmax;
end

function SkillInfoWindow:getMaxInduction(s)
	if curSkillTable[s] == nil then
		return 0;
	end

	return curSkillTable[s].inductionmax;
end

function SkillInfoWindow:SaveSettings()
	Turbine.PluginData.Save(Turbine.DataScope.Character, "SkillInfo", self.settings);
	Turbine.PluginData.Save(Turbine.DataScope.Account, "SkillInfo", self.timings);

	self.quickskills = { };
	for k1, v1 in pairs(self.settings.quickslots) do
		for k2, v2 in pairs(curSkillTable) do
			if v2.shortcut == v1 then
				self.quickskills[k1] = k2;
			end
		end
	end

	if self.timings.count > 0 then
		meanTime = self.timings.total / self.timings.count;
		minTime = meanTime - (meanTime - self.timings.minimum) * 5;
	else
		meanTime = 0.0;
		minTime = 0.0;
	end
end

function SkillInfoWindowLoadCharacterSettings()
	settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "SkillInfo");
	if type(settings) ~= "table" then
		settings = { };
	end

	if not settings.quickslots then
		settings.quickslots = { };
	end

	if not settings.trait then
		settings.trait = { };
	end

	if not settings.equip then
		settings.equip = { };
	end

	if not settings.set then
		settings.set = { };
	end

	if not settings.legacy then
		settings.legacy = { };
	end

	if not settings.power then
		settings.power = { };
	end

	return settings;
end

function SkillInfoWindowLoadAccountSettings()
	settings = Turbine.PluginData.Load(Turbine.DataScope.Account, "SkillInfo");
	if type(settings) ~= "table" then
		settings = { };
	end

	if not settings.count then
		settings.count = 0;
	end

	if not settings.total then
		settings.total = 0.0;
	end

	if not settings.minimum then
		settings.minimum = 0.0;
	end

	return settings;
end

SkillInfoCommand = class(Turbine.ShellCommand);

function SkillInfoCommand:Execute(command, arguments)
	local i = string.find(arguments, " ");
	local arg, rest;
	local time = Turbine.Engine.GetGameTime();

	if i ~= nil then
		arg = trim(string.sub(arguments, 1, i - 1));
		rest = trim(string.sub(arguments, i + 1, -1));
		if rest == "" then
			rest = nil;
		end
	else
		arg = arguments;
		rest = nil;
	end

	if arg == "toggle" then
		skillInfoWindow:SetVisible(not skillInfoWindow.visible);
	elseif arg == "list" then
		if rest == "trait" then
			Turbine.Shell.WriteLine("Traits:");
			for k in pairs(traitTable[skillInfoWindow.class]) do
				Turbine.Shell.WriteLine(k);
			end
		elseif rest == "legacy" then
			Turbine.Shell.WriteLine("Legacies:");
			for k in pairs(legacyTable[skillInfoWindow.class]) do
				Turbine.Shell.WriteLine(k);
			end
		elseif rest == "equip" then
			Turbine.Shell.WriteLine("Equipment:");
			for k in pairs(equipTable[skillInfoWindow.class]) do
				Turbine.Shell.WriteLine(k);
			end
		elseif rest == "set" then
			Turbine.Shell.WriteLine("Sets:");
			for k in pairs(setTable[skillInfoWindow.class]) do
				Turbine.Shell.WriteLine(k);
			end
		else
			Turbine.Shell.WriteLine("/skillinfo list <trait|legacy|equip|set>");
		end
	elseif arg == "trait" then
		if rest == nil then
			Turbine.Shell.WriteLine("Traits:");
			for k, v in pairs(skillInfoWindow.settings.trait) do
				Turbine.Shell.WriteLine(k);
			end
		else
			skillInfoWindow.settings.trait = { };
			for v in string.gmatch(rest, "[^,]+") do
				v = trim(v);
				if traitTable[skillInfoWindow.class][v] == nil then
					Turbine.Shell.WriteLine("Trait " .. v .. " not found.");
				else
					skillInfoWindow.settings.trait[v] = 1;
				end
			end
			
			Turbine.Shell.WriteLine("Traits set.");
			generateCurSkillTable(skillInfoWindow.settings.trait, skillInfoWindow.settings.legacy, skillInfoWindow.settings.equip, skillInfoWindow.settings.set, skillInfoWindow.class, skillInfoWindow.race, skillInfoWindow.settings.power)
			skillInfoWindow:UpdateMaxPower();
			for k, v in pairs(skillInfoWindow.qsHandlers) do
				v("!update", time, nil);
			end
			skillInfoWindow:SaveSettings();
		end
	elseif arg == "equip" then
		if rest == nil then
			Turbine.Shell.WriteLine("Equipment:");
			for k, v in pairs(skillInfoWindow.settings.equip) do
				Turbine.Shell.WriteLine(k .. " = " .. table.concat(v, ", "));
			end
		else
			arguments = rest;
			i = string.find(arguments, "=");
			if i ~= nil then
				arg = trim(string.sub(arguments, 1, i - 1));
				rest = trim(string.sub(arguments, i + 1, -1));
				if rest == "" then
					rest = nil;
				end
			else
				arg = arguments;
				rest = nil;
			end

			if rest == nil then
				skillInfoWindow.settings.equip[arg] = nil;
				Turbine.Shell.WriteLine("Equipment " .. arg .. " cleared.");
			else
				if equipTable[skillInfoWindow.class][arg] == nil then
					Turbine.Shell.WriteLine("Equipment " .. arg .. " not found.");
					return;
				else
					skillInfoWindow.settings.equip[arg] = { };
					for v in string.gmatch(rest, "[^,]+") do
						v = trim(v);
						table.insert(skillInfoWindow.settings.equip[arg], v);
					end
					if table.getn(skillInfoWindow.settings.equip[arg]) == 0 then
						skillInfoWindow.settings.equip[arg] = nil;
						Turbine.Shell.WriteLine("Equipment " .. arg .. " cleared.");
					else
						Turbine.Shell.WriteLine("Equipment " .. arg .. " set.");
					end
				end
			end

			generateCurSkillTable(skillInfoWindow.settings.trait, skillInfoWindow.settings.legacy, skillInfoWindow.settings.equip, skillInfoWindow.settings.set, skillInfoWindow.class, skillInfoWindow.race, skillInfoWindow.settings.power)
			skillInfoWindow:UpdateMaxPower();
			for k, v in pairs(skillInfoWindow.qsHandlers) do
				v("!update", time, nil);
			end
			skillInfoWindow:SaveSettings();
		end
	elseif arg == "set" then
		if rest == nil then
			Turbine.Shell.WriteLine("Set bonuses:");
			for k, v in pairs(skillInfoWindow.settings.set) do
				Turbine.Shell.WriteLine(k .. " = " .. table.concat(v, ", "));
			end
		else
			arguments = rest;
			i = string.find(arguments, "=");
			if i ~= nil then
				arg = trim(string.sub(arguments, 1, i - 1));
				rest = trim(string.sub(arguments, i + 1, -1));
				if rest == "" then
					rest = nil;
				end
			else
				arg = arguments;
				rest = nil;
			end

			if rest == nil then
				skillInfoWindow.settings.set[arg] = nil;
				Turbine.Shell.WriteLine("Set bonus " .. arg .. " cleared.");
			else
				if setTable[skillInfoWindow.class][arg] == nil then
					Turbine.Shell.WriteLine("Set bonus " .. arg .. " not found.");
					return;
				else
					skillInfoWindow.settings.set[arg] = { };
					for v in string.gmatch(rest, "[^,]+") do
						v = trim(v);
						local n = tonumber(v);
						if n ~= nil then
							table.insert(skillInfoWindow.settings.set[arg], n);
						end
					end
					if table.getn(skillInfoWindow.settings.set[arg]) == 0 then
						skillInfoWindow.settings.set[arg] = nil;
						Turbine.Shell.WriteLine("Set bonus " .. arg .. " cleared.");
					else
						Turbine.Shell.WriteLine("Set bonus " .. arg .. " set.");
					end
				end
			end

			generateCurSkillTable(skillInfoWindow.settings.trait, skillInfoWindow.settings.legacy, skillInfoWindow.settings.equip, skillInfoWindow.settings.set, skillInfoWindow.class, skillInfoWindow.race, skillInfoWindow.settings.power)
			skillInfoWindow:UpdateMaxPower();
			for k, v in pairs(skillInfoWindow.qsHandlers) do
				v("!update", time, nil);
			end
			skillInfoWindow:SaveSettings();
		end
	elseif arg == "legacy" then
		if rest == nil then
			Turbine.Shell.WriteLine("Legacies:");
			for k, v in pairs(skillInfoWindow.settings.legacy) do
				Turbine.Shell.WriteLine(k .. " = " .. table.concat(v, ", "));
			end
		else
			arguments = rest;
			i = string.find(arguments, "=");
			if i ~= nil then
				arg = trim(string.sub(arguments, 1, i - 1));
				rest = trim(string.sub(arguments, i + 1, -1));
				if rest == "" then
					rest = nil;
				end
			else
				arg = arguments;
				rest = nil;
			end

			if rest == nil then
				skillInfoWindow.settings.legacy[arg] = nil;
				Turbine.Shell.WriteLine("Legacy " .. arg .. " cleared.");
			else
				if legacyTable[skillInfoWindow.class][arg] == nil then
					Turbine.Shell.WriteLine("Legacy " .. arg .. " not found.");
					return;
				else
					skillInfoWindow.settings.legacy[arg] = { };
					for v in string.gmatch(rest, "[^,]+") do
						v = trim(v);
						table.insert(skillInfoWindow.settings.legacy[arg], v);
					end
					if table.getn(skillInfoWindow.settings.legacy[arg]) == 0 then
						skillInfoWindow.settings.legacy[arg] = nil;
						Turbine.Shell.WriteLine("Legacy " .. arg .. " cleared.");
					else
						Turbine.Shell.WriteLine("Legacy " .. arg .. " set.");
					end
				end
			end

			generateCurSkillTable(skillInfoWindow.settings.trait, skillInfoWindow.settings.legacy, skillInfoWindow.settings.equip, skillInfoWindow.settings.set, skillInfoWindow.class, skillInfoWindow.race, skillInfoWindow.settings.power)
			skillInfoWindow:UpdateMaxPower();
			for k, v in pairs(skillInfoWindow.qsHandlers) do
				v("!update", time, nil);
			end
			skillInfoWindow:SaveSettings();
		end
	elseif arg == "stopwatch" and (rest == "start" or rest == "stop") then
		if rest == "start" then
			if skillInfoWindow.stopwatch >= 0 then
				if skillInfoWindow.stopwatchCount > 0 then
					local mean = skillInfoWindow.stopwatchTotal / skillInfoWindow.stopwatchCount;
					Turbine.Shell.WriteLine("Average time: " .. mean);
				end
				Turbine.Shell.WriteLine("Stopwatch reset.");
			else
				Turbine.Shell.WriteLine("Stopwatch started.");
			end
			skillInfoWindow.stopwatch = 0;
			skillInfoWindow.stopwatchCount = 0;
			skillInfoWindow.stopwatchTotal = 0;
		elseif rest == "stop" then
			skillInfoWindow.stopwatch = -1;
			if skillInfoWindow.stopwatchCount > 0 then
				local mean = skillInfoWindow.stopwatchTotal / skillInfoWindow.stopwatchCount;
				Turbine.Shell.WriteLine("Average time: " .. mean);
			end
			Turbine.Shell.WriteLine("Stopwatch stopped.");
		end
	elseif arg == "calibrate" and (rest == "reset" or rest == "start" or rest == "load" or rest == "save" or rest == "status") then
		if rest == "reset" then
			skillInfoWindow.timings.count = 0;
			skillInfoWindow.timings.total = 0;
			skillInfoWindow.timings.minimum = 0;
			skillInfoWindow.calibrateCount = 0;
			skillInfoWindow.calibrateTotal = 0;
			skillInfoWindow.calibrateMin = 0;
			skillInfoWindow:SaveSettings();
		elseif rest == "start" then
			skillInfoWindow.calibrate = 0;
		elseif rest == "load" then
			skillInfoWindow.calibrateCount = 0;
			skillInfoWindow.calibrateTotal = 0;
			skillInfoWindow.calibrateMin = 0;
		elseif rest == "save" then
			if (skillInfoWindow.timings.count == 0 or
			    skillInfoWindow.timings.minimum > skillInfoWindow.calibrateMin) and
			   skillInfoWindow.calibrateCount ~= 0 then
				skillInfoWindow.timings.minimum = skillInfoWindow.calibrateMin;
			end
			skillInfoWindow.timings.count = skillInfoWindow.timings.count + skillInfoWindow.calibrateCount;
			skillInfoWindow.timings.total = skillInfoWindow.timings.total + skillInfoWindow.calibrateTotal;
			skillInfoWindow.calibrateCount = 0;
			skillInfoWindow.calibrateTotal = 0;
			skillInfoWindow.calibrateMin = 0;
			skillInfoWindow:SaveSettings();
		elseif rest == "status" then
			if skillInfoWindow.timings.count > 0 then
				Turbine.Shell.WriteLine("Mean: " .. (skillInfoWindow.timings.total / skillInfoWindow.timings.count));
				Turbine.Shell.WriteLine("Minimum: " .. skillInfoWindow.timings.minimum);
			else
				Turbine.Shell.WriteLine("Mean: " .. 0.0);
				Turbine.Shell.WriteLine("Minimum: " .. 0.0);
			end
		end
	else
		Turbine.Shell.WriteLine("usage: /skillinfo <toggle|trait [traits]|equip [equips]|set [sets]|legacy [legacies]|list <trait|equip|set|legacy>|stopwatch <start|stop>|calibrate <reset|load|save|start|status>>");
	end
end

function SkillInfoCommand:GetShortHelp()
	return "Quickslot tracker";
end

skillInfoCommand = SkillInfoCommand();
Turbine.Shell.AddCommand('skillinfo', skillInfoCommand);
_G.skillInfoWindow = SkillInfoWindow();